## Spell System developed by Talchas
## Spells written by Kael

from CvPythonExtensions import *
import PyHelpers
import CustomFunctions
import CvUtil 
## Smarter Orcs: needed for getInfoTypeForStringCached

PyInfo = PyHelpers.PyInfo
gc = CyGlobalContext()
cf = CustomFunctions.CustomFunctions()
PyPlayer = PyHelpers.PyPlayer
targetPlot = (-1,-1)
targetUnit = None
EventPickUnit = 6000

def clearTarget():
	targetPlot = (-1,-1)
	targetUnit = None

def target(plot):
	global targetPlot
	targetPlot = (plot.getX(),plot.getY())

def getUnitTarget():
	return targetUnit

def unitTarget(unit):
	global targetUnit
	plot = unit.plot()
	for i in range(0, plot.getNumUnits()):
		u=plot.getUnit(i)
		if u.getID() == unit.getID():
			targetUnit = u
			return

def canDisabledCastAny(caster):
#	if(caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'))):
#		return False
	return True

def canDisabledCast(caster, eSpell):
	if not canDisabledCastAny(caster):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_ADD_TO_CITY'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_BECOME_PATRIARCH'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_SACRIFICE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CONSUME_SOUL'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_PEACE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_PIRATE_COVE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_INQUISITION'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CONVERT_CITY'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CREATE_DEN'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_DROWN'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_COMMANDER_JOIN'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_BURNING_BLOOD_SELF'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CREW_BUCCANEERS'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CREW_LONGSHOREMEN'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CREW_NORMAL_CREW'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_CREW_SKELETON_CREW'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_HERALDS_CALL'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_SING'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_RECRUIT_MERCENARY'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_HELLFIRE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_SIRONAS_TOUCH'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_SPRINT'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_TAKE_AXE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_TRAIN_MACEMAN'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_TRAIN_DANCE_OF_BLADES'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_TRAIN_ESCAPE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_TRAIN_HASTE'):
		return False
	if eSpell == CvUtil.getInfoTypeForStringCached('SPELL_TRAIN_RAISE_SKELETON'):
		return False
	return True

def canCast(caster):
	if not canDisabledCastAny(caster):
		return False
	if(caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HAS_CAST1'))):
		return False
	if(caster.isMadeAttack()):
		return False
	return True

def doCast(caster):
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HAS_CAST1'),True)
	caster.setMadeAttack(True)

def AIBlock(caster):
	if canCast(caster) == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def inRange(caster, pPlot, iRange):
	if iRange == 0:
		if caster.plot().getX() != pPlot.getX():
			return False
		if caster.plot().getY() != pPlot.getY():
			return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION1')):
		iRange = iRange + 1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION2')):
		iRange = iRange + 1
	if caster.getX() - pPlot.getX() > iRange:
		return False
	if pPlot.getX() - caster.getX() > iRange:
		return False
	if caster.getY() - pPlot.getY() > iRange:
		return False
	if pPlot.getY() - caster.getY() > iRange:
		return False
	return True

def startWar(iPlayer,i2Player,caster,target):
	bValid = True
	iHiddenNationality = CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY')
	if caster.isHasPromotion(iHiddenNationality):
		bValid = False
	if target != -1:
		if target.isHasPromotion(iHiddenNationality):
			bValid = False
	if bValid:
		iTeam = gc.getPlayer(iPlayer).getTeam()
		i2Team = gc.getPlayer(i2Player).getTeam()
		eTeam = gc.getTeam(iTeam)
		if (eTeam.isAtWar(i2Team) == False and iTeam != i2Team):
			eTeam.declareWar(i2Team, False)

def reqAddToCity(caster):
	if not canCast(caster):
		return False
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_MANES'):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.getOwner() != caster.getOwner():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if pCity.getPopulation() > 7:
			return False
	return True

def spellAddToCity(caster):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCity.changePopulation(1)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM'), True)
	caster.kill(True,0)

def findTargetBanish(caster):
	iHiddenNationality = CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY')
	iMagicImmune = CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	iRange = 1
	iBestUnit = -1
	pBestUnit = -1
	iX = caster.getX()
	iY = caster.getY()
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION1')):
		iRange = iRange + 1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION2')):
		iRange = iRange + 1
	for iiX in range(iX-iRange, iX+iRange+1, 1):
		for iiY in range(iY-iRange, iY+iRange+1, 1):
			if not (iiX == iX and iiY == iY):
				pPlot = CyMap().plot(iiX,iiY)
				for i in range(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					p2Player = gc.getPlayer(pUnit.getOwner())
					e2Team = p2Player.getTeam()
					if (eTeam.isAtWar(e2Team) or pUnit.isHasPromotion(iHiddenNationality)):
						if (caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(iMagicImmune) == False):
							iUnit = 5 * pUnit.baseCombatStr(true)
							iUnit += pUnit.getExperience()
							if iUnit > iBestUnit:
								pBestUnit = pUnit
	return pBestUnit

def reqBanish(caster):
	if canCast(caster) == False:
		return False
	if findTargetBanish(caster) == -1:
		return False
	return True

def spellBanish(caster,target):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman():
		target = target[0]
	else:
		target = findTargetBanish(caster)
	if target.isResisted(caster,20) == False:
		CyInterface().addMessage(target.getOwner(),True,25,'Unit Banished.','AS2D_LOSS_LATE',1,'Art/Interface/Buttons/Spells/Banish.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
		CyInterface().addMessage(caster.getOwner(),True,25,'Enemy Unit Banished.','AS2D_LOSS_LATE',1,'Art/Interface/Buttons/Spells/Banish.dds',ColorTypes(7),target.getX(),target.getY(),True,True)
		target.kill(True,0)

def validBanish(caster,pPlot):
	iHiddenNationality = CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY')
	iMagicImmune = CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	list = []
	if pPlayer.isHuman() == False:
		list.append(findTargetBanish(caster))
		return list
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		p2Player = gc.getPlayer(pUnit.getOwner())
		e2Team = p2Player.getTeam()
		if (eTeam.isAtWar(e2Team) or pUnit.isHasPromotion(iHiddenNationality)):
			if (caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(iMagicImmune) == False):
				list.append(pUnit)
	return list

def reqBecomePatriarch(caster):
	if not canCast(caster):
		return False
	if (caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_HIGH_PRIEST_OF_KILMORPH') and caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_HIGH_PRIEST_OF_LEAVES') and caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_HIGH_PRIEST_OF_THE_ORDER') and caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_HIGH_PRIEST_OF_THE_OVERLORDS') and caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_HIGH_PRIEST_OF_THE_VEIL')):
		return False
	iPromPatriarch = CvUtil.getInfoTypeForStringCached('PROMOTION_PATRIARCH')
	if caster.isHasPromotion(iPromPatriarch):
		return False
	iPromKilmorph = CvUtil.getInfoTypeForStringCached('PROMOTION_RUNES_OF_KILMORPH')
	iPromLeaves = CvUtil.getInfoTypeForStringCached('PROMOTION_FELLOWSHIP_OF_LEAVES')
	iPromOrder = CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ORDER')
	iPromOverlords = CvUtil.getInfoTypeForStringCached('PROMOTION_OCTOPUS_OVERLORDS')
	iPromVeil = CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ASHEN_VEIL')
	if caster.isHasPromotion(iPromKilmorph):
		iProm = iPromKilmorph
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH')
	if caster.isHasPromotion(iPromLeaves):
		iProm = iPromLeaves
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES')
	if caster.isHasPromotion(iPromOrder):
		iProm = iPromOrder
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER')
	if caster.isHasPromotion(iPromOverlords):
		iProm = iPromOverlords
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS')
	if caster.isHasPromotion(iPromVeil):
		iProm = iPromVeil
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL')
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if pPlayer.isAlive():
			if pPlayer.getStateReligion() == iReligion:
				py = PyPlayer(iPlayer)
				for pUnit in py.getUnitList():
					if pUnit.isHasPromotion(iPromPatriarch):
						if pUnit.isHasPromotion(iProm):
							if caster.getLevel() <= pUnit.getLevel():
								return False
	return True

def spellBecomePatriarch(caster):
	doCast(caster)
	iPromPatriarch = CvUtil.getInfoTypeForStringCached('PROMOTION_PATRIARCH')
	iPromKilmorph = CvUtil.getInfoTypeForStringCached('PROMOTION_RUNES_OF_KILMORPH')
	iPromLeaves = CvUtil.getInfoTypeForStringCached('PROMOTION_FELLOWSHIP_OF_LEAVES')
	iPromOrder = CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ORDER')
	iPromOverlords = CvUtil.getInfoTypeForStringCached('PROMOTION_OCTOPUS_OVERLORDS')
	iPromVeil = CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ASHEN_VEIL')
	if caster.isHasPromotion(iPromKilmorph):
		iProm = iPromKilmorph
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH')
	if caster.isHasPromotion(iPromLeaves):
		iProm = iPromLeaves
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES')
	if caster.isHasPromotion(iPromOrder):
		iProm = iPromOrder
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER')
	if caster.isHasPromotion(iPromOverlords):
		iProm = iPromOverlords
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS')
	if caster.isHasPromotion(iPromVeil):
		iProm = iPromVeil
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL')
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if pPlayer.isAlive():
			if pPlayer.getStateReligion() == iReligion:
				py = PyPlayer(iPlayer)
				for pUnit in py.getUnitList():
					if pUnit.isHasPromotion(iPromPatriarch):
						if pUnit.isHasPromotion(iProm):
							pUnit.setHasPromotion(iPromPatriarch, False)
	caster.setHasPromotion(iPromPatriarch, True)

def reqBless(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DEMON')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD')) == False):
			if not pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BLESSED')):
				return True
	return False

def spellBless(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DEMON')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD')) == False):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BLESSED'),True)

def reqBloom(caster):
	if not canCast(caster):	return False
	pPlot = caster.plot()
	if pPlot.getFeatureType() != -1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	if pPlot.canHaveFeature(CvUtil.getInfoTypeForStringCached('FEATURE_FOREST_NEW')) == False:
		return False
	if pPlot.getOwner() != caster.getOwner():
		return False
	if pPlot.isCity():
		return False
	if pPlot.isPeak():
		return False
	return True

def spellBloom(caster):
	doCast(caster)
	pPlot = caster.plot()
	pPlot.setFeatureType(CvUtil.getInfoTypeForStringCached('FEATURE_FOREST_NEW'), 0)

def spellBreathFire(caster):
	doCast(caster)
	caster.setMadeAttack(False)	
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_METEOR'), caster.getX(), caster.getY(), UnitAITypes.UNITAI_SPELL)
	newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), True)
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT1')):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER1'), True)
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT2')):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER2'), True)
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT3')):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER3'), True)
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT4')):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER4'), True)
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT5')):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER5'), True)
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY')):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY'), True)

def reqBuild(caster,building):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.hasBuilding(CvUtil.getInfoTypeForStringCached(building)):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if pCity.getOwner() != caster.getOwner():
			return False
	return True

def spellBuild(caster,building):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCity.setHasRealBuilding(CvUtil.getInfoTypeForStringCached(building), True)

def spellBurningBlood(caster,target):
	doCast(caster)
	target = target[0]
	target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BURNING_BLOOD'), True)
	if CyGame().getSorenRandNum(100, "Burning Blood") <= 75:
		target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), True)

def validBurningBlood(caster,pPlot):
	list = []
	if inRange(caster,pPlot,0) == False:
		return list
	iBurningBlood = CvUtil.getInfoTypeForStringCached('PROMOTION_BURNING_BLOOD')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() == pUnit.getOwner() and pUnit.isHasPromotion(iBurningBlood) == False):
			list.append(pUnit)
	return list

def reqBurningBloodSelf(caster):
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_MOROI'):
		return False
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellBurningBloodSelf(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BURNING_BLOOD'), True)
	if CyGame().getSorenRandNum(100, "Burning Blood Self") <= 75:
		caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), True)

def reqCallHolyWar(caster):
	if not canCast(caster):
		return False
	if caster.getExperience() < 10:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	bValid = False
	for iPlayer2 in range(gc.getMAX_PLAYERS()):
		pPlayer2 = gc.getPlayer(iPlayer2)
		if pPlayer2.isAlive():
			if pPlayer.getStateReligion() == pPlayer2.getStateReligion():
				iTeam2 = gc.getPlayer(iPlayer2).getTeam()
				if eTeam.isAtWar(iTeam2) == False:
					bValid = True
	if bValid == False:
		return False
	for iPlayer2 in range(gc.getMAX_PLAYERS()):
		pPlayer2 = gc.getPlayer(iPlayer2)
		if pPlayer2.isAlive():
			iTeam2 = gc.getPlayer(iPlayer2).getTeam()
			if eTeam.isAtWar(iTeam2):
				if pPlayer.getStateReligion() != pPlayer2.getStateReligion():
					return True
	return False

def spellCallHolyWar(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	for iPlayer2 in range(gc.getMAX_PLAYERS()):
		pPlayer2 = gc.getPlayer(iPlayer2)
		if pPlayer2.isAlive():
			iTeam2 = gc.getPlayer(iPlayer2).getTeam()
			if eTeam.isAtWar(iTeam2):
				if pPlayer.getStateReligion() != pPlayer2.getStateReligion():
					for iPlayer3 in range(gc.getMAX_PLAYERS()):
						pPlayer3 = gc.getPlayer(iPlayer3)
						if pPlayer3.isAlive():
							iTeam3 = gc.getPlayer(iPlayer3).getTeam()
							eTeam3 = gc.getTeam(iTeam3)
							if pPlayer.getStateReligion() == pPlayer3.getStateReligion():
								if (eTeam.isAtWar(iTeam3) == False and eTeam3.isAtWar(iTeam2) == False):
									cf.FFHStartWar(iPlayer3, iPlayer2)
	caster.changeExperience(-10, -1)

def spellCharmPerson(caster,target):
	doCast(caster)
	target = target[0]
	pPlot = target.plot()
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_CHARM_PERSON'),point)
	iResistMod = 0
	if target.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LOYALTY')):
		iResistMod = iResistMod + 20
	if target.isResisted(caster,iResistMod) == False:
		CyInterface().addMessage(target.getOwner(),True,25,'Unit Charmed.','AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Promotions/Charmed.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
		CyInterface().addMessage(caster.getOwner(),True,25,'Unit Charmed.','AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Promotions/Charmed.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
		target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_CHARMED'), True)
		target.setMadeAttack(True)

def validCharmPerson(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_CHARMED')) == False):
			list.append(pUnit)
	return list

def reqCommanderJoin(caster):
	if canCast(caster) == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iCommander = CvUtil.getInfoTypeForStringCached('UNITCLASS_COMMANDER')
	pCommander = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitClassType() == iCommander):
			pCommander = pUnit
	if pCommander == -1:
		return False
	if caster.getUnitClassType() == iCommander:
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GREAT_COMMANDER')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED2')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED3')):
		return False
	if pPlayer.isHuman() == False:
		if caster.baseCombatStr(True) <= 5:
			return False
	return True

def spellCommanderJoin(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iCommander = CvUtil.getInfoTypeForStringCached('UNITCLASS_COMMANDER')
	pCommander = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.getUnitClassType() == iCommander):
			pCommander = pUnit
	if pCommander != -1:
		caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GREAT_COMMANDER'), True)
		pCommander.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM'), True)
		pCommander.kill(False,0)

def spellCommanderSplit(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_COMMANDER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GREAT_COMMANDER'), False)

def reqConsumeSoul(caster):
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_EATER_OF_DREAMS'):
		return False
	if canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.getPopulation() <=3:
		return False
	if pCity.getOwner() != caster.getOwner():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellConsumeSoul(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	i = pCity.getPopulation() -1
	pCity.setPopulation(i)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HAS_CAST1'),False)	
	caster.setMadeAttack(False)

def spellContagion(caster,target):
	doCast(caster)
	pPlot = target
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_CONTAGION'),point)
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isAlive() and pUnit.isResisted(caster,0) == False:
			iDmg = 20 + CyGame().getSorenRandNum(20, "Bob")
			pUnit.doDamage(2, iDmg, 40, caster)
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DISEASED'), True)

def validContagion(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() != pUnit.getOwner() and pUnit.isAlive()):
			list.append(pUnit)
	return list

def reqConvertCity(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.getOwner() == caster.getOwner():
		return False
	if (pCity.getOwner() == gc.getBARBARIAN_PLAYER() and caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_RANTINE')):
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			if pUnit.baseCombatStr(true) > caster.baseCombatStr(true):
				return False
		return True
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_BASIUM'):
		if pCity.hasBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_MERCURIAN_GATE')):
			return True
	return False

def spellConvertCity(caster):
	doCast(caster)
	pCity = caster.plot().getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())	
	pPlayer.acquireCity(pCity,false,false)

def reqCourage(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COURAGE')) == False):
				return True
	return False

def spellCourage(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isAlive():
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COURAGE'),True)

def reqCreateDen(caster):
	if not canCast(caster):
		return False
	iImprovement = -1
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_LION_PRIDE'):
		iImprovement = CvUtil.getInfoTypeForStringCached('IMPROVEMENT_LION_DEN')
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_BEAR'):
		iImprovement = CvUtil.getInfoTypeForStringCached('IMPROVEMENT_BEAR_DEN')
	if iImprovement == -1:
		return False
	if caster.getDamage() > 0:
		return False
	pPlot = caster.plot()
	if pPlot.isOwned():
		return False
	if pPlot.getNumUnits() != 1:
		return False
	if pPlot.getImprovementType() != -1:
		return False
	if pPlot.canHaveImprovement(iImprovement, caster.getOwner(), true) == False:
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-4, iX+5, 1):
		for iiY in range(iY-4, iY+5, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == iImprovement:
				return False
	return True

def spellCreateDen(caster):
	doCast(caster)
	pPlot = caster.plot()
	iImprovement = -1
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_LION_PRIDE'):
		iImprovement = CvUtil.getInfoTypeForStringCached('IMPROVEMENT_LION_DEN')
		iUnit = CvUtil.getInfoTypeForStringCached('UNIT_LION')
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_BEAR'):
		iImprovement = CvUtil.getInfoTypeForStringCached('IMPROVEMENT_BEAR_DEN')
		iUnit = CvUtil.getInfoTypeForStringCached('UNIT_BEAR')
	pPlot.setImprovementType(iImprovement)
	pPlot2 = cf.FFHFindClearPlot(-1, caster.plot())
	if pPlot2 != -1:
		caster.setXY(pPlot2.getX(), pPlot2.getY())
		pPlayer = gc.getPlayer(gc.getBARBARIAN_PLAYER())
		newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI)
		newUnit.convert(caster)

def reqCrewBuccaneers(caster):
	if not canCast(caster):
		return False
	if caster.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL'):
		return False
	pPlot = caster.plot()
	if (pPlot.isCity() == False and pPlot.getImprovementType() != CvUtil.getInfoTypeForStringCached('IMPROVEMENT_PIRATE_COVE')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BUCCANEERS')):
		return False
	if caster.maxMoves() <= 1:
		return False
	if caster.baseCombatStr(True) < 1:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == false:
		iUnit = caster.getUnitType()
		if (iUnit != CvUtil.getInfoTypeForStringCached('UNIT_FRIGATE') and iUnit != CvUtil.getInfoTypeForStringCached('UNIT_MAN_O_WAR')):
			return false
	return True
	
def spellCrewBuccaneers(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BUCCANEERS'), True)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LONGSHOREMEN'), False)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SKELETON_CREW'), False)


def reqCrewLongshoremen(caster):
	if not canCast(caster):
		return False
	if caster.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL'):
		return False
	pPlot = caster.plot()
	if (pPlot.isCity() == False and pPlot.getImprovementType() != CvUtil.getInfoTypeForStringCached('IMPROVEMENT_PIRATE_COVE')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LONGSHOREMEN')):
		return False
#	if (PyInfo.UnitInfo(caster.getUnitType()).getCargoSpace() == 0 and caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXPANDED_HULL')) == False):
#		return False
	if caster.cargoSpaceAvailable(-1, CvUtil.getInfoTypeForStringCached('DOMAIN_LAND')) == 0:
		return False
	if caster.baseCombatStr(True) < 1:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == false:
		iUnit = caster.getUnitType()
		if (iUnit != CvUtil.getInfoTypeForStringCached('UNIT_GALLEY') and iUnit != CvUtil.getInfoTypeForStringCached('UNIT_CARAVEL')):
			return false
	return True
	
def spellCrewLongshoremen(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BUCCANEERS'), False)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LONGSHOREMEN'), True)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SKELETON_CREW'), False)

def reqCrewNormalCrew(caster):
	if not canCast(caster):
		return False
	if caster.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL'):
		return False
	pPlot = caster.plot()
	if (pPlot.isCity() == False and pPlot.getImprovementType() != CvUtil.getInfoTypeForStringCached('IMPROVEMENT_PIRATE_COVE')):
		return False
	if (caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BUCCANEERS')) == False and caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SKELETON_CREW')) == False and caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LONGSHOREMEN')) == False):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True
	
def spellCrewNormalCrew(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BUCCANEERS'), False)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LONGSHOREMEN'), False)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SKELETON_CREW'), False)

def reqCrewSkeletonCrew(caster):
	if not canCast(caster):
		return False
	if caster.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL'):
		return False
	pPlot = caster.plot()
	if (pPlot.isCity() == False and pPlot.getImprovementType() != CvUtil.getInfoTypeForStringCached('IMPROVEMENT_PIRATE_COVE')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SKELETON_CREW')):
		return False
	if caster.baseCombatStr(True) < 1:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == false:
		iUnit = caster.getUnitType()
		if (iUnit != CvUtil.getInfoTypeForStringCached('UNIT_QUEEN_OF_THE_LINE') and iUnit != CvUtil.getInfoTypeForStringCached('UNIT_TRIREME') and iUnit != CvUtil.getInfoTypeForStringCached('UNIT_GALLEON')):
			return false
	return True
	
def spellCrewSkeletonCrew(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BUCCANEERS'), False)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LONGSHOREMEN'), False)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SKELETON_CREW'), True)

def spellCrush(caster,target):
	doCast(caster)
	pPlot = target
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_CRUSH'),point)
	for i in range(pPlot.getNumUnits()):
		iDmg = 20 + CyGame().getSorenRandNum(40, "Bob")
		pUnit = pPlot.getUnit(i)
		pUnit.doDamage(0, iDmg, 60, caster)

def validCrush(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if caster.getOwner() != pUnit.getOwner():
			list.append(pUnit)
	return list

def reqCureDisease(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iCount = 0
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DISEASED')) or pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_PLAGUED')) or pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_WITHERED'))):
			iCount = iCount + 1
	if iCount == 0:
		return False
	return True

def spellCureDisease(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DISEASED'), False)
		pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_PLAGUED'), False)
		pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_WITHERED'), False)

def reqDanceofBlades(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getSpecialUnitType() != CvUtil.getInfoTypeForStringCached('SPECIALUNIT_SPELL'):
			if pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DANCE_OF_BLADES')) == False:
				return True
	return False

def spellDanceofBlades(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getSpecialUnitType() != CvUtil.getInfoTypeForStringCached('SPECIALUNIT_SPELL'):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DANCE_OF_BLADES'),True)

def reqDefile(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FALLOUT'):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if (pPlayer.isHuman() and caster.getOwner() == pPlot.getOwner()):
		return True
	if pPlot.isOwned():
		iTeam = gc.getPlayer(caster.getOwner()).getTeam()
		i2Team = gc.getPlayer(pPlot.getOwner()).getTeam()
		eTeam = gc.getTeam(iTeam)
		if eTeam.isAtWar(i2Team) == False:
			return False
	return True

def spellDefile(caster):
	doCast(caster)
	pPlot = caster.plot()
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), caster, -1)
	pPlot.setFeatureType(CvUtil.getInfoTypeForStringCached('FEATURE_FALLOUT'), 0)

def reqDeclareNationality(caster):
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellDeclareNationality(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY'), False)
	
def spellDestroyUndead(caster,target):
	doCast(caster)
	pPlot = target
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_DESTROY_UNDEAD'),point)
	iUndead = CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(iUndead) and pUnit.isResisted(caster,0) == False):
			iDmg = pUnit.getDamage() + 60 + CyGame().getSorenRandNum(60, "Destroy Undead")
			pPlayer = gc.getPlayer(caster.getOwner())
			if pPlayer.getAlignment() == 1:
				iDmg = iDmg + 10
			pUnit.doDamage(3, iDmg, 100, caster)

def validDestroyUndead(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD'))):
			list.append(pUnit)
	return list

def reqDispelMagic(caster):
	if not canCast(caster):
		return False
	iBlessed = CvUtil.getInfoTypeForStringCached('PROMOTION_BLESSED')
	iBurningBlood = CvUtil.getInfoTypeForStringCached('PROMOTION_BURNING_BLOOD')
	iCharmed = CvUtil.getInfoTypeForStringCached('PROMOTION_CHARMED')
	iDanceOfBlades = CvUtil.getInfoTypeForStringCached('PROMOTION_DANCE_OF_BLADES')
	iEnchantedBlade = CvUtil.getInfoTypeForStringCached('PROMOTION_ENCHANTED_BLADE')
	iFairWinds = CvUtil.getInfoTypeForStringCached('PROMOTION_FAIR_WINDS')
	iFlamingArrows = CvUtil.getInfoTypeForStringCached('PROMOTION_FLAMING_ARROWS')
	iHasted = CvUtil.getInfoTypeForStringCached('PROMOTION_HASTED')
	iRegeneration = CvUtil.getInfoTypeForStringCached('PROMOTION_REGENERATION')
	iReversalOfFortune = CvUtil.getInfoTypeForStringCached('PROMOTION_REVERSAL_OF_FORTUNE')
	iRoot = CvUtil.getInfoTypeForStringCached('PROMOTION_ROOT')
	iShieldOfFaith = CvUtil.getInfoTypeForStringCached('PROMOTION_SHIELD_OF_FAITH')
	iSpellstaff = CvUtil.getInfoTypeForStringCached('PROMOTION_SPELLSTAFF')
	iSpiritGuide = CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRIT_GUIDE')
	iSpiritualHammer = CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRITUAL_HAMMER')
	iStoneskin = CvUtil.getInfoTypeForStringCached('PROMOTION_STONESKIN')
	iTreetopDefence = CvUtil.getInfoTypeForStringCached('PROMOTION_TREETOP_DEFENCE')
	iValor = CvUtil.getInfoTypeForStringCached('PROMOTION_VALOR')
	iWaterWalking = CvUtil.getInfoTypeForStringCached('PROMOTION_WATER_WALKING')
	iX = caster.getX()
	iY = caster.getY()
	iRange = 1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION1')):
		iRange = iRange + 1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION2')):
		iRange = iRange + 1
	for iiX in range(iX - iRange, iX + (iRange + 1), 1):
		for iiY in range(iY - iRange, iY + (iRange + 1), 1):
			pPlot = CyMap().plot(iiX,iiY)
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				if pUnit.getOwner() == caster.getOwner() and pUnit.isHasPromotion(iCharmed):
					return True
				if pUnit.getOwner() != caster.getOwner():
					if (pUnit.isHasPromotion(iBlessed) or pUnit.isHasPromotion(iBurningBlood) or pUnit.isHasPromotion(iDanceOfBlades) or pUnit.isHasPromotion(iEnchantedBlade) or pUnit.isHasPromotion(iFairWinds) or pUnit.isHasPromotion(iFlamingArrows) or pUnit.isHasPromotion(iHasted) or pUnit.isHasPromotion(iRegeneration) or pUnit.isHasPromotion(iReversalOfFortune) or pUnit.isHasPromotion(iRoot) or pUnit.isHasPromotion(iShieldOfFaith) or pUnit.isHasPromotion(iSpellstaff) or pUnit.isHasPromotion(iSpiritGuide) or pUnit.isHasPromotion(iSpiritualHammer) or pUnit.isHasPromotion(iStoneskin) or pUnit.isHasPromotion(iTreetopDefence) or pUnit.isHasPromotion(iValor) or pUnit.isHasPromotion(iWaterWalking)):
						return True
	return False

def spellDispelMagic(caster):
	doCast(caster)
	iBlessed = CvUtil.getInfoTypeForStringCached('PROMOTION_BLESSED')
	iBurningBlood = CvUtil.getInfoTypeForStringCached('PROMOTION_BURNING_BLOOD')
	iCharmed = CvUtil.getInfoTypeForStringCached('PROMOTION_CHARMED')
	iDanceOfBlades = CvUtil.getInfoTypeForStringCached('PROMOTION_DANCE_OF_BLADES')
	iEnchantedBlade = CvUtil.getInfoTypeForStringCached('PROMOTION_ENCHANTED_BLADE')
	iFairWinds = CvUtil.getInfoTypeForStringCached('PROMOTION_FAIR_WINDS')
	iFlamingArrows = CvUtil.getInfoTypeForStringCached('PROMOTION_FLAMING_ARROWS')
	iHasted = CvUtil.getInfoTypeForStringCached('PROMOTION_HASTED')
	iRegeneration = CvUtil.getInfoTypeForStringCached('PROMOTION_REGENERATION')
	iReversalOfFortune = CvUtil.getInfoTypeForStringCached('PROMOTION_REVERSAL_OF_FORTUNE')
	iRoot = CvUtil.getInfoTypeForStringCached('PROMOTION_ROOT')
	iShieldOfFaith = CvUtil.getInfoTypeForStringCached('PROMOTION_SHIELD_OF_FAITH')
	iSpellstaff = CvUtil.getInfoTypeForStringCached('PROMOTION_SPELLSTAFF')
	iSpiritGuide = CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRIT_GUIDE')
	iSpiritualHammer = CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRITUAL_HAMMER')
	iStoneskin = CvUtil.getInfoTypeForStringCached('PROMOTION_STONESKIN')
	iTreetopDefence = CvUtil.getInfoTypeForStringCached('PROMOTION_TREETOP_DEFENCE')
	iValor = CvUtil.getInfoTypeForStringCached('PROMOTION_VALOR')
	iWaterWalking = CvUtil.getInfoTypeForStringCached('PROMOTION_WATER_WALKING')
	iX = caster.getX()
	iY = caster.getY()
	iRange = 1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION1')):
		iRange = iRange + 1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION2')):
		iRange = iRange + 1
	iPlayer = caster.getOwner()
	for iiX in range(iX - iRange, iX + (iRange + 1), 1):
		for iiY in range(iY - iRange, iY + (iRange + 1), 1):
			pPlot = CyMap().plot(iiX,iiY)
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				iPlayer2 = pUnit.getOwner()
				if  iPlayer == iPlayer2 and pUnit.isHasPromotion(iCharmed):
					pUnit.setHasPromotion(iCharmed, False)
					CyInterface().addMessage(iPlayer,True,25,'Charm Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
				if (iPlayer != iPlayer2 and pUnit.isResisted(caster,0) == False):
					if pUnit.isHasPromotion(iBlessed):
						pUnit.setHasPromotion(iBlessed, False)
						CyInterface().addMessage(iPlayer,True,25,'Bless Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Bless Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iBurningBlood):
						pUnit.setHasPromotion(iBurningBlood, False)
						CyInterface().addMessage(iPlayer,True,25,'Burning Blood Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Burning Blood Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iDanceOfBlades):
						pUnit.setHasPromotion(iDanceOfBlades, False)
						CyInterface().addMessage(iPlayer,True,25,'Dance of Blades Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Dance of Blades Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iEnchantedBlade):
						pUnit.setHasPromotion(iEnchantedBlade, False)
						CyInterface().addMessage(iPlayer,True,25,'Enchanted Blade Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Enchanted Blade Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iFairWinds):
						pUnit.setHasPromotion(iFairWinds, False)
						CyInterface().addMessage(iPlayer,True,25,'Fair Winds Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Fair Winds Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iFlamingArrows):
						pUnit.setHasPromotion(iFlamingArrows, False)
						CyInterface().addMessage(iPlayer,True,25,'Flaming Arrows Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Flaming Arrows Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iHasted):
						pUnit.setHasPromotion(iHasted, False)
						CyInterface().addMessage(iPlayer,True,25,'Haste Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Haste Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iRegeneration):
						pUnit.setHasPromotion(iRegeneration, False)
						CyInterface().addMessage(iPlayer,True,25,'Regeneration Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Regeneration Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iReversalOfFortune):
						pUnit.setHasPromotion(iReversalOfFortune, False)
						CyInterface().addMessage(iPlayer,True,25,'Reversal of Fortune Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Reversal of Fortune Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iRoot):
						pUnit.setHasPromotion(iRoot, False)
						CyInterface().addMessage(iPlayer,True,25,'Entangle Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Entangle Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iShieldOfFaith):
						pUnit.setHasPromotion(iShieldOfFaith, False)
						CyInterface().addMessage(iPlayer,True,25,'Shield of Faith Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Shield of Faith Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iSpellstaff):
						pUnit.setHasPromotion(iSpellstaff, False)
						CyInterface().addMessage(iPlayer,True,25,'Spellstaff Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Spellstaff Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iSpiritGuide):
						pUnit.setHasPromotion(iSpiritGuide, False)
						CyInterface().addMessage(iPlayer,True,25,'Spirit Guide Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Spirit Guide Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iSpiritualHammer):
						pUnit.setHasPromotion(iSpiritualHammer, False)
						CyInterface().addMessage(iPlayer,True,25,'Spiritual Hammer Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Spiritual Hammer Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iStoneskin):
						pUnit.setHasPromotion(iStoneskin, False)
						CyInterface().addMessage(iPlayer,True,25,'Stoneskin Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Stoneskin Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iTreetopDefence):
						pUnit.setHasPromotion(iTreetopDefence, False)
						CyInterface().addMessage(iPlayer,True,25,'Treetop Defence Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Treetop Defence Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iValor):
						pUnit.setHasPromotion(iValor, False)
						CyInterface().addMessage(iPlayer,True,25,'Valor Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Valor Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
					if pUnit.isHasPromotion(iWaterWalking):
						pUnit.setHasPromotion(iWaterWalking, False)
						CyInterface().addMessage(iPlayer,True,25,'Water Walking Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)
						CyInterface().addMessage(iPlayer2,True,25,'Water Walking Dispeled.','',1,'Art/Interface/Buttons/Spells/Dispelmagic.dds',ColorTypes(8),pUnit.getX(),pUnit.getY(),True,True)

def spellDomination(caster,target):
	doCast(caster)
	target = target[0]
	pAttacker = target
	if target.isResisted(caster,30):
		pUnit = caster
		pAttacker = target
		pPlot = target.plot()
		CyInterface().addMessage(target.getOwner(),True,25,'Domination failed, you have gained a caster.','',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
		CyInterface().addMessage(caster.getOwner(),True,25,'Domination failed, you have lost your caster.','',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(8),caster.getX(),caster.getY(),True,True)
	else:
		pUnit = target
		pAttacker = caster
		pPlot = caster.plot()
		pPlayer = gc.getPlayer(caster.getOwner())
		CyInterface().addMessage(target.getOwner(),True,25,'Unit lost to Domination.','',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
		CyInterface().addMessage(caster.getOwner(),True,25,'Unit gained by Domination.','',1,'Art/Interface/Buttons/Spells/Domination.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_CHARM_PERSON'),point)
	cf.FFHConvert(pAttacker, pUnit, pUnit.getUnitType(), True)

def validDomination(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')) == False):
			list.append(pUnit)
	return list

def reqDrown(caster):
	if not canCast(caster):
		return False
	if caster.getUnitClassType() != CvUtil.getInfoTypeForStringCached('UNITCLASS_WARRIOR'):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.hasBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_OVERLORDS')) == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS'):
		return False
	if pPlayer.getGold() < 60:
		return False
	if (pPlayer.getGold() < 120 and pPlayer.isHuman() == False):
		return False
	return True

def spellDrown(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_THE_DROWN'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	newUnit.convert(caster)
	pPlayer.changeGold(-60)
	newUnit.finishMoves()

def reqEarthquake(caster):
	if not canCast(caster):
		return False
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		eTeam = pPlayer.getTeam()
		for iiX in range(iX-1, iX+2, 1):
			for iiY in range(iY-1, iY+2, 1):
				pPlot = CyMap().plot(iiX,iiY)
				p2Player = gc.getPlayer(pPlot.getOwner())
				if pPlot.isOwned():
					e2Team = gc.getTeam(p2Player.getTeam())
					if e2Team.isAtWar(eTeam) == False:
						return False
	return True

def spellEarthquake(caster):
	doCast(caster)
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = pPlayer.getTeam()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if (pPlot.isCity() or pPlot.getImprovementType() != -1):
				startWar(caster.getOwner(), pPlot.getOwner(), caster, -1)
			if pPlot.isCity():
				pCity = pPlot.getPlotCity()
				for i in range(gc.getNumBuildingInfos()):
					iRnd = CyGame().getSorenRandNum(100, "Bob")
					if (gc.getBuildingInfo(i).getConquestProbability() != 100 and iRnd <= 25):
							pCity.setHasRealBuilding(i, False)
			iRnd = CyGame().getSorenRandNum(100, "Bob")
			if iRnd <= 25:
				pPlot.setImprovementType(-1)

def reqEnchantedBlade(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_MELEE'):
			if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ENCHANTED_BLADE')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_RUSTED')) == False):
				return True
	return False

def spellEnchantedBlade(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_MELEE'):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ENCHANTED_BLADE'),True)
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_RUSTED'),False)

def reqEnchantSpellstaff(caster):
	if not canCast(caster):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SPELLSTAFF')):
		return False
	return True

def spellEnchantSpellstaff(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SPELLSTAFF'),True)

def spellEnervation(caster,target):
	doCast(caster)
	target = target[0]
	pPlot = target.plot()
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_WITHER'),point)
	if target.isResisted(caster,0) == False:
		CyInterface().addMessage(target.getOwner(),True,25,'Unit Enervated.','AS2D_LOSS_MIDDLE',1,'Art/Interface/Buttons/Spells/Enervation.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
		target.changeExperience(-1 * target.getExperience() / 2, -1)
		startWar(caster.getOwner(), target.getOwner(), caster, target)

def validEnervation(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')) == False):
			list.append(pUnit)
	return list

def spellEntangle(caster,target):
	doCast(caster)
	pPlot = target
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_ENTANGLE'),point)
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isResisted(caster,0) == False:
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ROOT'), True)

def validEntangle(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')) == False):
			list.append(pUnit)
	return list

def reqEscape(caster):
	if not canCast(caster):
		return False
	if caster.getOwner() == gc.getBARBARIAN_PLAYER():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if (pPlayer.isHuman() == False and caster.getDamage() >= 50):
		return False
	return True

def reqFairWinds(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iFairWinds = CvUtil.getInfoTypeForStringCached('PROMOTION_FAIR_WINDS')
	iNaval = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL')
	bValid = False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == iNaval:
			if pUnit.isHasPromotion(iFairWinds) == False:
				bValid = True
	if bValid == False:
		return False
	return True

def spellFairWinds(caster):
	doCast(caster)
	pPlot = caster.plot()
	iFairWinds = CvUtil.getInfoTypeForStringCached('PROMOTION_FAIR_WINDS')
	iNaval = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == iNaval:
			pUnit.setHasPromotion(iFairWinds,True)

def reqFeast(caster):
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.getPopulation() <=3:
		return False
	if pCity.getOwner() != caster.getOwner():
		return False
	return True

def spellFeast(caster):
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	i = pCity.getPopulation() -1
	pCity.setPopulation(i)
	caster.changeExperience(i-2, -1)
	pCity.changeHurryAngerTimer(3)

def reqFeed(caster):
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	bValid = False
	if pPlot.getNumUnits() == 1:
		return False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			bValid = True
	if bValid == False:
		return False
	return True

def spellFeed(caster,target):
	target = target[0]
	caster.setDamage(caster.getDamage() - gc.getMAX_HIT_POINTS()/4, True)# Smarter Orcs defect fix.
	caster.setMadeAttack(False)
	if target.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_BLOODPET'):
		iMoves = caster.getMoves() - gc.getMOVE_DENOMINATOR()
		if iMoves < 0:
			iMoves = 0
		caster.setMoves(iMoves)
	target.kill(True,0)

def validFeed(caster,pPlot):
	list = []
	if (pPlot.getX() != caster.getX() or pPlot.getY() != caster.getY()):
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() == pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VAMPIRE')) == False):
			list.append(pUnit)
	return list

def reqFlamingArrows(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_ARCHER'):
			if not pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_FLAMING_ARROWS')):
				return True
	return False

def spellFlamingArrows(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_ARCHER'):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_FLAMING_ARROWS'),True)

def reqFoundTemple(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	iReligion = -1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ORDER')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_RUNES_OF_KILMORPH')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_FELLOWSHIP_OF_LEAVES')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_OCTOPUS_OVERLORDS')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ASHEN_VEIL')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL')
	if iReligion == -1:
		return False
	if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER'):
		iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_ORDER')
		if pCity.isHolyCityByType(CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL')):
			return False
	if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH'):
		iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_KILMORPH')
	if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES'):
		iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_LEAVES')
	if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS'):
		iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_OVERLORDS')
	if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'):
		iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_VEIL')
		if pCity.isHolyCityByType(CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER')):
			return False
	if pCity.hasBuilding(iBuilding):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False and pCity.getOwner() != caster.getOwner():
		return False
	return True

def spellFoundTemple(caster):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	iReligion = -1
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ORDER')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_RUNES_OF_KILMORPH')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_FELLOWSHIP_OF_LEAVES')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_OCTOPUS_OVERLORDS')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS')
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ASHEN_VEIL')):
		iReligion = CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL')
	if iReligion != -1:
		if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER'):
			iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_ORDER')
			pCity.setHasReligion(CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'), False, True, True)
		if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH'):
			iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_KILMORPH')
		if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES'):
			iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_LEAVES')
		if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS'):
			iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_OVERLORDS')
		if iReligion == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'):
			iBuilding = CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_VEIL')
			pCity.setHasReligion(CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER'), False, True, True)
		pCity.setHasReligion(iReligion, True, True, True)
		pCity.setHasRealBuilding(iBuilding, True)
		CyInterface().addMessage(caster.getOwner(),True,25,'Temple founded.','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/Promotions/Priest.dds',ColorTypes(8),pCity.getX(),pCity.getY(),True,True)
		caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM'), True)
		caster.kill(True, 0)

def reqGiftVampirism(caster):
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			if not pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VAMPIRE')):
				if pUnit.getLevel() >= 6:
					return True
				if (pUnit.getLevel() >= 4 and pUnit.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_MOROI')):
					return True
	return False

def spellGiftVampirism(caster):
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DEMON')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD')) == False):
			if not pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VAMPIRE')):
				if pUnit.getLevel() >= 6:
					pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VAMPIRE'),True)
				if (pUnit.getLevel() >= 4 and pUnit.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_MOROI')):
					pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VAMPIRE'),True)

def spellGraftFlesh(caster,target):
	doCast(caster)
	pTarget1 = target[0]
	pTarget2 = target[1]
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_FLESH_GOLEM'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	iStr = (pTarget1.baseCombatStr(True) + pTarget2.baseCombatStr(True)) / 2
	newUnit.changeExtraCombatStr(iStr - newUnit.baseCombatStr(True))
	iStr = (pTarget1.baseCombatStr(False) + pTarget2.baseCombatStr(False)) / 2
	newUnit.changeExtraCombatDefense(iStr - newUnit.baseCombatStr(False))
	for iCount in range(gc.getNumPromotionInfos()):
		if (pTarget1.isHasPromotion(iCount) or pTarget2.isHasPromotion(iCount)):
			newUnit.setHasPromotion(iCount, True)
	pTarget1.kill(True,0)
	pTarget2.kill(True,0)

def validGraftFlesh(caster,pPlot):
	list = []
	if inRange(caster,pPlot,0) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.isAlive()):
			list.append(pUnit)
	return list

def reqHaste(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iHaste = CvUtil.getInfoTypeForStringCached('PROMOTION_HASTED')
	bValid = False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.maxMoves() > 0:
			if (pUnit.isHasPromotion(iHaste) == False and pUnit.isAlive()):
				bValid = True
	if bValid == False:
		return False
	return True

def spellHaste(caster):
	doCast(caster)
	pPlot = caster.plot()
	iHaste = CvUtil.getInfoTypeForStringCached('PROMOTION_HASTED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.maxMoves() > 0 and pUnit.isAlive()):
			pUnit.setHasPromotion(iHaste,True)

def reqHeal(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iPoisoned = CvUtil.getInfoTypeForStringCached('PROMOTION_POISONED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getDamage() > 0):
			return True
		if pUnit.isHasPromotion(iPoisoned):
			return True
	return False

def spellHeal(caster,amount):
	doCast(caster)
	pPlot = caster.plot()
	iPoisoned = CvUtil.getInfoTypeForStringCached('PROMOTION_POISONED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		pUnit.setHasPromotion(iPoisoned,False)
		if pUnit.isAlive():
			pUnit.changeDamage(-(amount * gc.getDefineINT('HEALING_FACTOR')),0) #player doesn't matter - it won't kill # Smarter Orcs - Healing factor.
	if caster.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_LIFESPARK'):
		caster.kill(True, 0)

def reqHellfire(caster):
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_INFERNAL'):
		return False
	pPlot = caster.plot()
	if pPlot.isCity():
		return False
	if pPlot.isWater():
		return False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-2, iX+3, 1):
		for iiY in range(iY-2, iY+3, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_HELLFIRE'):
				return False
	if pPlayer.isHuman() == False:
		if pPlot.isOwned():
			if pPlot.getOwner() == caster.getOwner():
				return False
	return True

def spellHellfire(caster):
	doCast(caster)
	pPlot = caster.plot()
	pPlot.setImprovementType(CvUtil.getInfoTypeForStringCached('IMPROVEMENT_HELLFIRE'))

def reqHeraldsCall(caster):
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_HERALD'):
		return False
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	bValid = False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			bValid = True
	if bValid == False:
		return False
	return True

def spellHeraldsCall(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VALOR'),True)
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BURNING_BLOOD'), True)
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COURAGE'), True)
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LOYALTY'), True)
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), True)

def spellHideousThoughts(caster,target):
	doCast(caster)
	target = target[0]
	if (caster.getOwner() == target.getOwner() or target.isResisted(caster,0) == False):
		target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ENRAGED'), True)
		iLife = gc.getMAX_HIT_POINTS() - target.getDamage()
		target.setDamage(gc.getMAX_HIT_POINTS() - (iLife / 2), True) # Smarter Orcs - defect fix.

def validHideousThoughts(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isAlive():
			list.append(pUnit)
	return list

def reqInquisition(caster):
	if caster.getUnitClassType() != CvUtil.getInfoTypeForStringCached('UNITCLASS_INQUISITOR'):
		return False
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	StateBelief = pPlayer.getStateReligion()
	if (StateBelief != gc.getPlayer(pCity.getOwner()).getStateReligion()):
		return False
	for iTarget in range(gc.getNumReligionInfos()):
		if (StateBelief != iTarget and pCity.isHasReligion(iTarget) and pCity.isHolyCityByType(iTarget) == False):
			return True
	return False

def spellInquisition(caster):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	StateBelief = gc.getPlayer(pCity.getOwner()).getStateReligion()
	iRnd = CyGame().getSorenRandNum(4, "Bob")
	if StateBelief == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER'):
		iRnd = iRnd - 1
	for iTarget in range(gc.getNumReligionInfos()):
		if (not StateBelief == iTarget and pCity.isHasReligion(iTarget) and not pCity.isHolyCityByType(iTarget)):
			pCity.setHasReligion(iTarget, False, True, True)
			iRnd = iRnd + 1
			for i in range(gc.getNumBuildingInfos()):
				if gc.getBuildingInfo(i).getPrereqReligion() == iTarget:
					pCity.setHasRealBuilding(i, False)
	if iRnd >= 1:
		pCity.changeHurryAngerTimer(iRnd)

def reqLichdom(caster):
	if not canCast(caster):
		return False
	if caster.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_LICH'):
		return False
	if caster.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_FLESH_GOLEM'):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_LICH')) >= 3:
		return False
	return True

def spellLichdom(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_LICH'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	newUnit.convert(caster)
	newUnit.finishMoves()
	newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION1'), True)
	newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT1'), True)

def reqLifecycle(caster):
	if not canCast(caster):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LIFECYCLE')):
		return False
	return True

def spellLifecycle(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LIFECYCLE'), True)

def reqLoyalty(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LOYALTY')) == False and pUnit.getOwner() == caster.getOwner()):
			return True
	return False

def spellLoyalty(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getOwner() == caster.getOwner()):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LOYALTY'),True)

def reqMaelstrom(caster):
	if not canCast(caster):
		return False
	iX = caster.getX()
	iY = caster.getY()
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	if pPlayer.isHuman() == False:
		bValid = False
		eTeam = gc.getTeam(pPlayer.getTeam())
		for iiX in range(iX-2, iX+3, 1):
			for iiY in range(iY-2, iY+3, 1):
				if not (iiX == iX and iiY == iY):
					pPlot = CyMap().plot(iiX,iiY)
					for i in range(pPlot.getNumUnits()):
						pUnit = pPlot.getUnit(i)
						p2Player = gc.getPlayer(pUnit.getOwner())
						e2Team = p2Player.getTeam()
						if eTeam.isAtWar(e2Team):
							bValid = True
		if bValid == False:
			return False
	return True

def spellMaelstrom(caster):
	doCast(caster)
	iX = caster.getX()
	iY = caster.getY()
	iDmg = 50
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	eTeam = gc.getTeam(pPlayer.getTeam())
	for iiX in range(iX-2, iX+3, 1):
		for iiY in range(iY-2, iY+3, 1):
			if not (iiX == iX and iiY == iY):
				pPlot = CyMap().plot(iiX,iiY)
				for i in range(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					p2Player = gc.getPlayer(pUnit.getOwner())
					e2Team = p2Player.getTeam()
					if eTeam.isAtWar(e2Team):
						insDmg = (iDmg / 2) + CyGame().getSorenRandNum(iDmg, "Maelstrom")
						pUnit.doDamage(5, insDmg, 60, caster)

def reqMutation(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MUTATED')) == False and pUnit.getOwner() == caster.getOwner()):
			return True
	return False

def spellMutation(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			cf.FFHMutate(pUnit)

def reqPeace(caster):
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_CORLINDALE'):
		return False
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellPeace(caster):
	doCast(caster)
	eTeam = gc.getTeam(gc.getPlayer(caster.getOwner()).getTeam())
	for iPlayer in range(gc.getMAX_PLAYERS()):
		pPlayer = gc.getPlayer(iPlayer)
		if (pPlayer.isAlive() and iPlayer != caster.getOwner() and iPlayer != gc.getBARBARIAN_PLAYER()):
			i2Team = gc.getPlayer(iPlayer).getTeam()
			if eTeam.isAtWar(i2Team):
				eTeam.makePeace(i2Team)
	cf.FFHChangeArmageddonCounter(-1 * (CyGame().getArmageddonCounter() / 2), caster.getOwner())
	caster.kill(True, 0)

def spellPillarofFire(caster,target):
	doCast(caster)
	pPlot = target
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_PILLAR_OF_FIRE'),point)
	iDamageType = 4
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ASHEN_VEIL')):
		iDamageType = 7
	for i in range(pPlot.getNumUnits() - 1, -1, -1):
		iDmg = 15 + CyGame().getSorenRandNum(30, "Bob")
		pUnit = pPlot.getUnit(i)
		pUnit.doDamage(3, iDmg, 60, caster)
		if pUnit.getDamage() < 100:
			iDmg = 15 + CyGame().getSorenRandNum(30, "Bob")
			pUnit.doDamage(iDamageType, iDmg, 60, caster)
	if (pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FOREST') or pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_JUNGLE') or pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FOREST_NEW')):
		if CyGame().getSorenRandNum(100, "Fire Spread") <= gc.getDefineINT('FIRE_EFFECT_SPREAD_CHANCE'):
			pPlot.setImprovementType(CvUtil.getInfoTypeForStringCached('IMPROVEMENT_SMOKE'))

def validPillarofFire(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if caster.getOwner() != pUnit.getOwner():
			list.append(pUnit)
	return list

def reqPirateCove(caster):
	if caster.getUnitClassType() != CvUtil.getInfoTypeForStringCached('UNITCLASS_WORKER'):
		return False
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_LANUN'):
		return False
	if pPlayer.isHuman() == False:
		return False
	iX = caster.getX()
	iY = caster.getY()
	pPlot = caster.plot()
	if pPlot.isWater():
		return False
	if pPlot.area().getNumTiles() == 1:
		return False
	if pPlot.getNumUnits() > 1:
		return False
	if pPlot.isCity():
		return False
	if (pPlot.isOwned() and pPlot.getOwner() != caster.getOwner()):
		return False
	if pPlot.getImprovementType() != -1:
		return False
	bValid = False
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.isWater():
				bValid = True
	if bValid == False:
		return False
	for iiX in range(iX-2, iX+3, 1):
		for iiY in range(iY-2, iY+3, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_PIRATE_COVE'):
				return False
	return True

def spellPirateCove(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	caster.setXY(pPlayer.getCapitalCity().getX(), pPlayer.getCapitalCity().getY())
	pPlot.setBonusType(-1)
	pPlot.setFeatureType(-1, -1)
	pPlot.setPlotType(PlotTypes.PLOT_OCEAN, True, True)
	pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_COAST'),True,True)
	pPlot.setImprovementType(CvUtil.getInfoTypeForStringCached('IMPROVEMENT_PIRATE_COVE'))
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM'), True)
	caster.kill(True, 0)
	CyMap().recalculateAreas()

def reqPoisonedBlade(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_RECON'):
			if not pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_POISONED_BLADE')):
				return True
	return False

def spellPoisonedBlade(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_RECON'):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_POISONED_BLADE'),True)

def spellRage(caster,target):
	doCast(caster)
	target = target[0]
	if target.isResisted(caster,0) == False:
		pPlot = cf.FFHFindClearPlot(-1, target.plot())
		if pPlot != -1:
			CyInterface().addMessage(target.getOwner(),True,25,'Unit Enraged.','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/Promotions/Enraged.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
			CyInterface().addMessage(caster.getOwner(),True,25,'Unit Enraged.','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/Promotions/Enraged.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
			bPlayer = gc.getPlayer(gc.getBARBARIAN_PLAYER())
			newUnit = bPlayer.initUnit(target.getUnitType(), pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI)
			newUnit.setDamage(target.getDamage(), False)
			newUnit.setExperience(target.getExperience(), -1)
			newUnit.setLevel(target.getLevel())
			for iCount in range(gc.getNumPromotionInfos()):
				if target.isHasPromotion(iCount):
					newUnit.setHasPromotion(iCount, True)
			target.kill(True,0)

def validRage(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')) == False):
			list.append(pUnit)
	return list

def reqRaiseSkeleton(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isWater():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	py = PyPlayer(caster.getOwner())
	iNum = 0
	iChanneling1 = CvUtil.getInfoTypeForStringCached('PROMOTION_CHANNELING1')
	iDeath1 = CvUtil.getInfoTypeForStringCached('PROMOTION_DEATH1')
	for pUnit in py.getUnitList():
		if (pUnit.isHasPromotion(iChanneling1) and pUnit.isHasPromotion(iDeath1)):
			iNum = iNum + 1
	if pPlayer.getBuildingClassCount(CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_TOWER_OF_NECROMANCY')) > 0:
		iNum = iNum + 5
	if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_SKELETON')) >= iNum:
		return False
	return True

def reqRebuildBarnaxus(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(pCity.getOwner())
	if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_LUCHUIRP'):
		return False
	bValid = False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_LUCHUIRP'):
			bValid = True
	if bValid == False:
		return False
	return True

def spellRebuildBarnaxus(caster):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(pCity.getOwner())
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_BARNAXUS'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	newUnit.setDamage((gc.getMAX_HIT_POINTS()*3)/4, False)# Smarter Orcs defect fix.
	newUnit.finishMoves()
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_PIECES_OF_BARNAXUS'), False)

def reqRecruit(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	return True

def spellRecruit(caster):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	iLoop = (pCity.getPopulation() / 3) + 1
	if pCity.hasBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_TEMPLE_OF_THE_ORDER')):
		iLoop = iLoop * 2
	for i in range(iLoop):
		iRnd = CyGame().getSorenRandNum(100, "Bob")
		iUnit = -1
		if iRnd <= 10:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_SCOUT')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_HUNTING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_HUNTER')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_ANIMAL_HANDLING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_RANGER')
		elif iRnd <= 20:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_SCOUT')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_HUNTING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_HUNTER')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_POISONS')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_ASSASSIN')
		elif iRnd <= 30:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_SCOUT')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_HORSEBACK_RIDING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_HORSEMAN')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_STIRRUPS')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_HORSE_ARCHER')
		elif iRnd <= 40:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_SCOUT')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_HORSEBACK_RIDING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_HORSEMAN')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_TRADE')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_CHARIOT')
		elif iRnd <= 50:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_WARRIOR')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_BRONZE_WORKING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_AXEMAN')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_IRON_WORKING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_MACEMAN')
		elif iRnd <= 60:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_WARRIOR')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_BRONZE_WORKING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_AXEMAN')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_METAL_CASTING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_PIKEMAN')
		elif iRnd <= 70:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_WARRIOR')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_ARCHERY')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_ARCHER')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_BOWYERS')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_LONGBOWMAN')
		elif iRnd <= 80:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_WARRIOR')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_ARCHERY')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_ARCHER')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_ENGINEERING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_CROSSBOWMAN')
		elif iRnd <= 90:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_PROPHET2')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_KNOWLEDGE_OF_THE_ETHER')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_ADEPT')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_SORCERY')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_MAGE')
		elif iRnd <= 100:
			iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_PROPHET2')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_KNOWLEDGE_OF_THE_ETHER')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_ADEPT')
			if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_SUMMONING')):
				iUnit = CvUtil.getInfoTypeForStringCached('UNITCLASS_CONJURER')
		if iUnit != -1:
			infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
			iUnit = infoCiv.getCivilizationUnits(iUnit)
			if iUnit != -1:
				newUnit = pPlayer.initUnit(iUnit, caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_RECRUITER'), False)
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_DONAL'):
		caster.kill(True, 0)

def reqRecruitMercenary(caster):
	if not canCast(caster):
		return False
	if (caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_MERCENARY') and caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_MAGNADINE')):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iCost = 240
	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_HIPPUS'):
		iCost = iCost / 2
	if pPlayer.getGold() < iCost:
		return False
	if pPlayer.isHuman() == False:
		if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_KHAZAD'):
			return False
		if pPlayer.getGold() < iCost * 2:
			return False
		iX = caster.getX()
		iY = caster.getY()
		eTeam = gc.getTeam(pPlayer.getTeam())
		for iiX in range(iX-1, iX+2, 1):
			for iiY in range(iY-1, iY+2, 1):
				pPlot = CyMap().plot(iiX,iiY)
				for i in range(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					p2Player = gc.getPlayer(pUnit.getOwner())
					e2Team = p2Player.getTeam()
					if eTeam.isAtWar(e2Team) == True:
						return True
		return False
	return True

def spellRecruitMercenary(caster):
	doCast(caster)
	iCost = -240
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_HIPPUS'):
		iCost = iCost / 2
	newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_MERCENARY'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
	newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HAS_CAST1'), True)
	newUnit.finishMoves()
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_MAGNADINE'):
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_LOYALTY'), True)
	pPlayer.changeGold(iCost)

def reqRegeneration(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iTarget = 0
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getDamage() > 0 and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_REGENERATION')) == False):
				iTarget = iTarget + 1
	if iTarget == 0:
		return False
	return True

def spellRegeneration(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and pUnit.getDamage() > 0):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_REGENERATION'),True)

def reqRepair(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iGolem = CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM')
	iNaval = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL')
	iSiege = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_SIEGE')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iSiege or pUnit.getUnitCombatType() == iNaval or pUnit.isHasPromotion(iGolem)):
			if pUnit.getDamage() > 0:
				return True
	return False

def spellRepair(caster,amount):
	doCast(caster)
	pPlot = caster.plot()
	iGolem = CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM')
	iNaval = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL')
	iSiege = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_SIEGE')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iSiege or pUnit.getUnitCombatType() == iNaval or pUnit.isHasPromotion(iGolem)):
			pUnit.changeDamage(-amount,0)

def reqRessurection(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.getBonusType(-1) != CvUtil.getInfoTypeForStringCached('BONUS_MANA_LIFE'):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iHero = cf.FFHGetHero(pPlayer)
	if iHero == -1:
		return False
	if CyGame().isUnitClassMaxedOut(iHero, 0) == False:
		return False
	if pPlayer.getUnitClassCount(iHero) > 0:
		return False
	return True

def spellRessurection(caster):
	doCast(caster)
	pPlot = caster.plot()
	pPlot.setBonusType(-1)
	pPlot.setImprovementType(-1)
	pPlayer = gc.getPlayer(caster.getOwner())
	iHero = cf.FFHGetHero(pPlayer)
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUnit = infoCiv.getCivilizationUnits(iHero)
	newUnit = pPlayer.initUnit(iUnit, pPlot.getX(), pPlot.getY(), UnitAITypes.NO_UNITAI)
	CyInterface().addMessage(caster.getOwner(),True,25,'Hero Ressurected.','AS2D_CHARM_PERSON',1,'Art/Interface/Buttons/Spells/Ressurection.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)

def reqRestoreCity(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.getImprovementType() != CvUtil.getInfoTypeForStringCached('IMPROVEMENT_CITY_RUINS'):
		return False
	if pPlot.isOwned():
		if pPlot.getOwner() != caster.getOwner():
			return False
	iX = caster.getX()
	iY = caster.getY()
	for iiX in range(iX-3, iX+4, 1):
		for iiY in range(iY-3, iY+4, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.isCity():
				return False
	return True

def spellRestoreCity(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = pPlayer.initCity(caster.getX(), caster.getY())
	cf.FFHNewCity(pCity)

def reqReversalofFortune(caster):
	if not canCast(caster):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_REVERSAL_OF_FORTUNE')):
		return False
	return True

def spellReversalofFortune(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_REVERSAL_OF_FORTUNE'),True)

def reqRighteousCause(caster):
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	iTarget = -1
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.isCity():
				pCity = pPlot.getPlotCity()
				if gc.getPlayer(pCity.getOwner()).getTeam() != gc.getPlayer(caster.getOwner()).getTeam():
					if pCity.isNoUnhappiness() == False:
						iTarget = iTarget +1
	if iTarget == -1:
		return False
	if pPlayer.isHuman() == False:
		return False
	return True

def spellRighteousCause(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.isCity():
				if pPlot.getPlotCity().getOwner() != caster.getOwner():
					pCity = pPlot.getPlotCity()
					for i in range(max(0,pCity.unhappyLevel(0))):
						newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached('UNIT_CRUSADER'), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
					startWar(caster.getOwner(), pCity.getOwner(), caster, -1)
					caster.kill(True, 0)

def reqRingofFlames(caster):
	if not canCast(caster):
		return False
	iX = caster.getX()
	iY = caster.getY()
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	if pPlayer.isHuman() == False:
		eTeam = gc.getTeam(pPlayer.getTeam())
		for iiX in range(iX-1, iX+2, 1):
			for iiY in range(iY-1, iY+2, 1):
				if not (iiX == iX and iiY == iY):
					pPlot = CyMap().plot(iiX,iiY)
					for i in range(pPlot.getNumUnits()):
						pUnit = pPlot.getUnit(i)
						p2Player = gc.getPlayer(pUnit.getOwner())
						e2Team = p2Player.getTeam()
						if eTeam.isAtWar(e2Team) == False:
							return False
	return True

def spellRingofFlames(caster):
	doCast(caster)
	iX = caster.getX()
	iY = caster.getY()
	iDmg = 20
	if caster.getUnitType() == CvUtil.getInfoTypeForStringCached('UNIT_MESHABBER'):
		iDmg = iDmg * 2	
	iPlayer = caster.getOwner()
	pPlayer = gc.getPlayer(iPlayer)
	eTeam = pPlayer.getTeam()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			if not (iiX == iX and iiY == iY):
				pPlot = CyMap().plot(iiX,iiY)
				for i in range(pPlot.getNumUnits()):
					pUnit = pPlot.getUnit(i)
					insDmg = (iDmg / 2) + CyGame().getSorenRandNum(iDmg, "Ring of Flames")
					pUnit.doDamage(3, insDmg, 40, caster)
				if (pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FOREST') or pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_JUNGLE') or pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FOREST_NEW')):
					if CyGame().getSorenRandNum(100, "Fire Spread") <= gc.getDefineINT('FIRE_EFFECT_SPREAD_CHANCE'):
						pPlot.setImprovementType(CvUtil.getInfoTypeForStringCached('IMPROVEMENT_SMOKE'))

def reqRoar(caster):
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	iDragon = CvUtil.getInfoTypeForStringCached('PROMOTION_CULT_OF_THE_DRAGON')
	iTarget = -1
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				if (pUnit.getOwner() != caster.getOwner() and pUnit.isHasPromotion(iDragon)):
					iTarget = iTarget + 1
	if iTarget == -1:
		return False
	return True

def spellRoar(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	iX = caster.getX()
	iY = caster.getY()
	iDragon = CvUtil.getInfoTypeForStringCached('PROMOTION_CULT_OF_THE_DRAGON')
	iLoyalty = CvUtil.getInfoTypeForStringCached('PROMOTION_LOYALTY')
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				if (pUnit.getOwner() != caster.getOwner() and pUnit.isHasPromotion(iDragon)):
					if pUnit.isHasPromotion(iLoyalty) == False:
						newUnit = pPlayer.initUnit(pUnit.getUnitType(), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
						newUnit.finishMoves()
						newUnit.setDamage(gc.getMAX_HIT_POINTS()/2, False)# Smarter Orcs defect fix.
						newUnit.setExperience(pUnit.getExperience(), -1)
						newUnit.setLevel(pUnit.getLevel())
						for iCount in range(gc.getNumPromotionInfos()):
							if (pUnit.isHasPromotion(iCount)):
								newUnit.setHasPromotion(iCount, True)
						newUnit.setHasPromotion(iDragon, False)
					pUnit.kill(True, 0)

def spellRust(caster,target):
	doCast(caster)
	target = target[0]
	target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_RUSTED'),True)
	target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_BRONZE_WEAPONS'),False)
	target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_IRON_WEAPONS'),False)
	target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MITHRIL_WEAPONS'),False)
	if target.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_MELEE'):
		iDmg = target.getDamage() + gc.getMAX_HIT_POINTS()/10 + CyGame().getSorenRandNum(20, "Bob") # Smarter Orcs defect fix.
		if iDmg >= gc.getMAX_HIT_POINTS():
			target.kill(True, 0)
		else:
			target.setDamage(iDmg, True)

def validRust(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	iClockworkGolem = CvUtil.getInfoTypeForStringCached('UNIT_CLOCKWORK_GOLEM')
	iCopperGolem = CvUtil.getInfoTypeForStringCached('UNIT_COPPER_GOLEM')
	iIronGolem = CvUtil.getInfoTypeForStringCached('UNIT_IRON_GOLEM')
	iMelee = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_MELEE')
	iRusted = CvUtil.getInfoTypeForStringCached('PROMOTION_RUSTED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		iUType = pUnit.getUnitType()
		if (caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(iRusted) == False):
			if (pUnit.getUnitCombatType() == iMelee or iUType == iCopperGolem or iUType == iIronGolem or iUType == iClockworkGolem):
				list.append(pUnit)
	return list

def reqSacrifice(caster):
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	if pPlot.getPlotCity().hasBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_DEMONS_ALTAR')) == False:
		return False
	if caster.getLevel() < 2:
		return False
	if caster.isAlive() == False:
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED2')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED3')):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellSacrifice(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	eTeam = gc.getTeam(pPlayer.getTeam())
	iTech = pPlayer.getCurrentResearch()
	iNum = 10 + (caster.getLevel() * caster.getLevel())
	eTeam.changeResearchProgress(iTech, iNum, caster.getOwner())
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_THE_ASHEN_VEIL'), True)
	caster.kill(True, 0)

def reqSanctify(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	bValid = False
	if pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FALLOUT'):
		bValid = True
	if pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_CITY_RUINS'):
		bValid = True
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.getHellCount() > 0:
				bValid = True
	if bValid == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if (pPlayer.isHuman() == False and caster.getOwner() != pPlot.getOwner()):
		return False
	return True

def spellSanctify(caster):
	doCast(caster)
	pPlot = caster.plot()
	if pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FALLOUT'):
		pPlot.setFeatureType(-1, -1)
	if pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_CITY_RUINS'):
		pPlot.setImprovementType(-1)
		cf.FFHChangeArmageddonCounter(-1, caster.getOwner())
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.getHellCount() > 0:
				pPlot.changeHellCount(pPlot.getHellCount() * -1)

def reqSandLion(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if (pPlot.getTerrainType() != CvUtil.getInfoTypeForStringCached('TERRAIN_DESERT') and pPlot.getTerrainType() != CvUtil.getInfoTypeForStringCached('TERRAIN_BURNING_SANDS')):
		return False
	return True

def reqScorch(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if (pPlot.getTerrainType() != CvUtil.getInfoTypeForStringCached('TERRAIN_PLAINS') and pPlot.getTerrainType() != CvUtil.getInfoTypeForStringCached('TERRAIN_FIELDS_OF_PERDITION')):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if caster.getOwner() == pPlot.getOwner():
			return False
	return True

def spellScorch(caster):
	doCast(caster)
	pPlot = caster.plot()
	if pPlot.getTerrainType() == CvUtil.getInfoTypeForStringCached('TERRAIN_PLAINS'):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_DESERT'),True,True)
	if pPlot.getTerrainType() == CvUtil.getInfoTypeForStringCached('TERRAIN_FIELDS_OF_PERDITION'):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_BURNING_SANDS'),True,True)
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), caster, -1)

def reqShieldofFaith(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SHIELD_OF_FAITH')) == False:
			return True
	return False

def spellShieldofFaith(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SHIELD_OF_FAITH'),True)

def reqSing(caster):
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_GUYBRUSH'):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellSing(caster):
	pPlot = caster.plot()
	point = pPlot.getPoint()
	iRnd = CyGame().getSorenRandNum(100, "Sing")
	szText = "AS3D_SING1"
	if iRnd > 25:
		szText = "AS3D_SING2"
	if iRnd > 50:
		szText = "AS3D_SING3"
	if iRnd > 75:
		szText = "AS3D_SING4"
	CyAudioGame().Play3DSound(szText,point.x,point.y,point.z)

def reqSironasTouch(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getBuildingClassCount(CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_SHRINE_OF_SIRONA')) == 0:
		return False
	if caster.isAlive() == False:
		return False
	if caster.getDamage() == 0:
		return False
	if pPlayer.isFeatAccomplished(FeatTypes.FEAT_POPULATION_2_BILLION):
		return False
	if pPlayer.isHuman() == False:
		if caster.getDamage() < 15:
			return False
	return True

def spellSironasTouch(caster):
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlayer.setFeatAccomplished(FeatTypes.FEAT_POPULATION_2_BILLION, True)
	caster.changeDamage(-15,0)

def reqSpellstaff(caster):
	if canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellSpellstaff(caster):
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HAS_CAST1'),False)	
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SPELLSTAFF'),False)
	caster.setMadeAttack(False)

def reqSpiritGuide(caster):
	if not canCast(caster):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRIT_GUIDE')):
		return False
	return True

def spellSpiritGuide(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRIT_GUIDE'),True)

def reqSpiritualHammer(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iDisciple = CvUtil.getInfoTypeForStringCached('UNITCOMBAT_DISCIPLE')
	iSpiritualHammer = CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRITUAL_HAMMER')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == iDisciple and pUnit.getOwner() == caster.getOwner()):
			if pUnit.isHasPromotion(iSpiritualHammer) == False:
				return True
	return False

def spellSpiritualHammer(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_DISCIPLE') and pUnit.getOwner() == caster.getOwner()):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SPIRITUAL_HAMMER'),True)

def reqSpring(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	bFlames = false
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FLAMES') or pPlot2.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_SMOKE'):
				bFlames = true
	if bFlames == False:
		if pPlot.getTerrainType() != CvUtil.getInfoTypeForStringCached('TERRAIN_DESERT'):
			return False
		if pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FLOOD_PLAINS'):
			return False
		if pPlayer.isHuman() == False:
			if caster.getOwner() != pPlot.getOwner():
				return False
	if pPlayer.isHuman() == False:
		if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_INFERNAL'):
			return False
	return True

def spellSpring(caster):
	doCast(caster)
	pPlot = caster.plot()
	if (pPlot.getTerrainType() == CvUtil.getInfoTypeForStringCached('TERRAIN_DESERT') and pPlot.getFeatureType() != CvUtil.getInfoTypeForStringCached('FEATURE_FLOOD_PLAINS')):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_PLAINS'),True,True)
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot2 = CyMap().plot(iiX,iiY)
			if pPlot2.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FLAMES'):
				pPlot2.setFeatureType(-1, -1)
			if pPlot2.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_SMOKE'):
				pPlot2.setImprovementType(-1)

def reqSprint(caster):
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_CENTAUR'):
		return False
	if (caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HASTED')) or caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_FATIGUED'))):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		return False
	return True

def spellSprint(caster):
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HASTED'),True)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_FATIGUED'),True)

def reqStoneskin(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	iStoneskin = CvUtil.getInfoTypeForStringCached('PROMOTION_STONESKIN')
	bValid = False
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(iStoneskin) == False and pUnit.isAlive()):
			bValid = True
	if bValid == False:
		return False
	return True

def spellStoneskin(caster):
	doCast(caster)
	pPlot = caster.plot()
	iStoneskin = CvUtil.getInfoTypeForStringCached('PROMOTION_STONESKIN')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isAlive():
			pUnit.setHasPromotion(iStoneskin,True)

def reqSummonGuardianVines(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isWater():
		return False
	if pPlot.isCity():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	py = PyPlayer(caster.getOwner())
	iNum = 0
	iSummoning = CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONING')
	iNature2 = CvUtil.getInfoTypeForStringCached('PROMOTION_NATURE2')
	for pUnit in py.getUnitList():
		if (pUnit.isHasPromotion(iSummoning) and pUnit.isHasPromotion(iNature2)):
			iNum = iNum + 1
	if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_GUARDIAN_VINES')) >= iNum:
		return False
	return True

def reqSummonKraken(caster):
	if not canCast(caster):
		return False
	iX = caster.getX()
	iY = caster.getY()
	bValid = False
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			if pPlot.isWater():
				bValid = True
	if bValid == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	py = PyPlayer(caster.getOwner())
	iNum = 0
	iDivine = CvUtil.getInfoTypeForStringCached('PROMOTION_DIVINE')
	iWater3 = CvUtil.getInfoTypeForStringCached('PROMOTION_WATER3')
	for pUnit in py.getUnitList():
		if (pUnit.isHasPromotion(iDivine) and pUnit.isHasPromotion(iWater3)):
			iNum = iNum + 1
	if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_KRAKEN')) >= iNum:
		return False
	return True

def reqSummonTreant(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if (pPlot.getFeatureType() != CvUtil.getInfoTypeForStringCached('FEATURE_FOREST') and pPlot.getFeatureType() != CvUtil.getInfoTypeForStringCached('FEATURE_FOREST_ANCIENT')):
		return False
	if pPlot.isWater():
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	py = PyPlayer(caster.getOwner())
	iNum = 0
	iSummoning = CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONING')
	iNature3 = CvUtil.getInfoTypeForStringCached('PROMOTION_NATURE3')
	for pUnit in py.getUnitList():
		if (pUnit.isHasPromotion(iSummoning) and pUnit.isHasPromotion(iNature3)):
			iNum = iNum + 1
	if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_TREANT')) >= iNum:
		return False
	return True

def spellSummon(caster,unitType):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	iLoop = 1
	if unitType == 'UNIT_METEOR':
		iLoop = 3
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_TWINCAST')):
		iLoop = iLoop * 2
	for i in range(iLoop):
		newUnit = pPlayer.initUnit(CvUtil.getInfoTypeForStringCached(unitType), caster.getX(), caster.getY(), UnitAITypes.UNITAI_SPELL)
		newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), True)
		if (unitType == 'UNIT_TIGER' or unitType == 'UNIT_SKELETON' or unitType == 'UNIT_KRAKEN' or unitType == 'UNIT_GUARDIAN_VINES' or unitType == 'UNIT_TREANT'):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), False)
			newUnit.finishMoves()
			newUnit.setMadeAttack(True)
		if (unitType == 'UNIT_IMP' or unitType == 'UNIT_DJINN'):
			promotions = [ 'PROMOTION_AIR1','PROMOTION_BODY1','PROMOTION_CHAOS1','PROMOTION_DEATH1','PROMOTION_DIMENSIONAL1','PROMOTION_EARTH1','PROMOTION_ENCHANTMENT1','PROMOTION_ENTROPY1','PROMOTION_FIRE1','PROMOTION_LAW1','PROMOTION_LIFE1','PROMOTION_MIND1','PROMOTION_NATURE1','PROMOTION_SPIRIT1','PROMOTION_WATER1' ]
			for i in promotions:
				if CyGame().getSorenRandNum(15, "Bob") == 1:
					newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached(i), True)
		if (newUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED')) and pPlayer.hasTrait(CvUtil.getInfoTypeForStringCached('TRAIT_SUMMONER')) and newUnit.getSpecialUnitType() != CvUtil.getInfoTypeForStringCached('SPECIALUNIT_SPELL')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED'), False)
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED3'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION1')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MOBILITY1'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EXTENSION2')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_MOBILITY2'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT1')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER1'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT2')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER2'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT3')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER3'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT4')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER4'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_COMBAT5')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_EMPOWER5'), True)
		if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY')):
			newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_HIDDEN_NATIONALITY'), True)
		newUnit.changeExtraCombatStr(gc.getDefineINT('STR_MODIFIER_SUMMON'))
		newUnit.changeExtraCombatDefense(gc.getDefineINT('STR_MODIFIER_SUMMON'))
		if (unitType == 'UNIT_AIR_ELEMENTAL' or unitType == 'UNIT_KIKIJUB' or unitType == 'UNIT_EARTH_ELEMENTAL' or unitType == 'UNIT_SAND_LION' or unitType == 'UNIT_FIRE_ELEMENTAL' or unitType == 'UNIT_DJINN' or unitType == 'UNIT_GUARDIAN_VINES' or unitType == 'UNIT_TREANT' or unitType == 'UNIT_LIGHTNING_ELEMENTAL'):
			if pPlayer.getBuildingClassCount(CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_TOWER_OF_THE_ELEMENTS')) > 0:
				newUnit.changeExtraCombatStr(1)
				newUnit.changeExtraCombatDefense(1)
		if unitType == 'UNIT_SAND_LION':
			if pPlot.getTerrainType() == CvUtil.getInfoTypeForStringCached('TERRAIN_BURNING_SANDS'):
				newUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_STIGMATA'), True)
		if unitType == 'UNIT_FIRE_ELEMENTAL':
			if pPlot.getFeatureType() == CvUtil.getInfoTypeForStringCached('FEATURE_FLAMES'):
				newUnit.changeExtraCombatStr(1)
				newUnit.changeExtraCombatDefense(1)

def reqTakeAxe(caster):
	if canCast(caster) == False:
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	pAxeHolder = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ORTHUSS_AXE'))):
			pAxeHolder = pUnit
	if pAxeHolder == -1:
		return False
	if canCast(pAxeHolder) == False:
		return False
	if caster.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_NAVAL'):
		return False
	if caster.getUnitCombatType() == CvUtil.getInfoTypeForStringCached('UNITCOMBAT_SIEGE'):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ORTHUSS_AXE')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED2')):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_SUMMONED3')):
		return False
	if pPlayer.isHuman() == False:
		if caster.baseCombatStr(True) - 2 <= pAxeHolder.baseCombatStr(True):
			return False
	return True

def spellTakeAxe(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	pPlot = caster.plot()
	pAxeHolder = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (caster.getOwner() == pUnit.getOwner() and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ORTHUSS_AXE'))):
			pAxeHolder = pUnit
	if pAxeHolder != -1:
		caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ORTHUSS_AXE'), True)
		pAxeHolder.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_ORTHUSS_AXE'), False)

def spellTeleport(caster,loc):
	doCast(caster)
	player = caster.getOwner()
	pPlayer = gc.getPlayer(player)
	pCity = pPlayer.getCapitalCity()
	caster.setXY(pCity.getX(), pCity.getY())

def reqTrain(caster,promotion):
	if not canCast(caster):
		return False
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_GOVANNON'):
		return False
	iPromotion = CvUtil.getInfoTypeForStringCached(promotion)
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.getOwner() == caster.getOwner() and pUnit.isHasPromotion(iPromotion) == False):
			if (pUnit.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_DISCIPLE') and pUnit.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_ANIMAL') and pUnit.isAlive()):
				return True
	return False

def spellTrain(caster,promotion):
	doCast(caster)
	iPromotion = CvUtil.getInfoTypeForStringCached(promotion)
	iChanneling1 = CvUtil.getInfoTypeForStringCached('PROMOTION_CHANNELING1')
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			if (pUnit.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_DISCIPLE') and pUnit.getUnitCombatType() != CvUtil.getInfoTypeForStringCached('UNITCOMBAT_ANIMAL') and pUnit.isAlive()):
				pUnit.setHasPromotion(iPromotion, True)
				pUnit.setHasPromotion(iChanneling1, True)

def reqTrainMaceman(caster):
	if not canCast(caster):
		return False
	if caster.getUnitType() != CvUtil.getInfoTypeForStringCached('UNIT_BATTLEMASTER'):
		return False
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			if pUnit.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_AXEMAN'):
				if (pPlayer.getGold() >= 125 and pPlayer.isHuman()):
					return True
				if (pPlayer.getGold() >= 250 and pPlayer.isHuman() == False):
					return True
	return False

def spellTrainMaceman(caster):
	doCast(caster)
	pPlot = caster.plot()
	pPlayer = gc.getPlayer(caster.getOwner())
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())
	iUpgrade = -1
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.getOwner() == caster.getOwner():
			if pUnit.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_AXEMAN'):
				if iUpgrade == -1:
					iUpgrade = i
				elif pUnit.getLevel() >= pPlot.getUnit(iUpgrade).getLevel():
					iUpgrade = i
	if iUpgrade != -1:
		pUnit = pPlot.getUnit(iUpgrade)
		newUnit = pPlayer.initUnit(infoCiv.getCivilizationUnits(CvUtil.getInfoTypeForStringCached('UNITCLASS_MACEMAN')), caster.getX(), caster.getY(), UnitAITypes.NO_UNITAI)
		newUnit.finishMoves()
		newUnit.setDamage(pUnit.getDamage(), False)
		newUnit.setExperience(pUnit.getExperience(), -1)
		newUnit.setLevel(pUnit.getLevel())
		for iCount in range(gc.getNumPromotionInfos()):
			if pUnit.isHasPromotion(iCount):
				newUnit.setHasPromotion(iCount, True)
		pPlayer.changeGold(-125)
		pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_GOLEM'), true)
		pUnit.kill(True,0)

def reqTransmutation(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.getOwner() != caster.getOwner():
		return False
	if (pPlot.getBonusType(-1) != CvUtil.getInfoTypeForStringCached('BONUS_COPPER') and pPlot.getBonusType(-1) != CvUtil.getInfoTypeForStringCached('BONUS_GOLD')):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman() == False:
		if (pPlot.getBonusType(-1) == CvUtil.getInfoTypeForStringCached('BONUS_COPPER') and pPlayer.countOwnedBonuses(CvUtil.getInfoTypeForStringCached('BONUS_COPPER')) >= 2 and pPlayer.countOwnedBonuses(CvUtil.getInfoTypeForStringCached('BONUS_GOLD')) == 0):
			return True
		if (pPlot.getBonusType(-1) == CvUtil.getInfoTypeForStringCached('BONUS_GOLD') and pPlayer.countOwnedBonuses(CvUtil.getInfoTypeForStringCached('BONUS_GOLD')) >= 2 and pPlayer.countOwnedBonuses(CvUtil.getInfoTypeForStringCached('BONUS_COPPER')) == 0):
			return True
		return False
	return True

def spellTransmutation(caster):
	doCast(caster)
	pPlot = caster.plot()
	iBonus = -1
	if pPlot.getBonusType(-1) == CvUtil.getInfoTypeForStringCached('BONUS_COPPER'):
		iBonus = CvUtil.getInfoTypeForStringCached('BONUS_GOLD')
	if pPlot.getBonusType(-1) == CvUtil.getInfoTypeForStringCached('BONUS_GOLD'):
		iBonus = CvUtil.getInfoTypeForStringCached('BONUS_COPPER')
	if iBonus != -1:
		pPlot.setBonusType(iBonus)

def reqTreetopDefence(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if (pPlot.getFeatureType() != CvUtil.getInfoTypeForStringCached('FEATURE_FOREST') and pPlot.getFeatureType() != CvUtil.getInfoTypeForStringCached('FEATURE_FOREST_ANCIENT')):
		return False
	iCount = -1
	for i in range(pPlot.getNumUnits()):
		if pPlot.getUnit(i).isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_TREETOP_DEFENCE')) == False:
			iCount = iCount +1
	if iCount == -1:
		return False
	return True

def spellTreetopDefence(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pPlot.getUnit(i).setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_TREETOP_DEFENCE'),True)

def reqTrust(caster):
	if not canCast(caster):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.getBuildingClassCount(CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_TRUST')) > 0:
		return False
	if pPlayer.isBarbarian():
		return False
	return True

def spellTrust(caster):
	doCast(caster)
	pPlayer = gc.getPlayer(caster.getOwner())
	pCity = pPlayer.getCapitalCity()
	pCity.setHasRealBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_TRUST'), True)

def spellTsunami(caster,target):
	doCast(caster)
	pPlot = target
	if pPlot.isOwned():
		startWar(caster.getOwner(), pPlot.getOwner(), caster, -1)
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if pUnit.isResisted(caster,0) == False:
			iDmg = 20 + CyGame().getSorenRandNum(20, "Bob")
			pUnit.doDamage(1, iDmg, 40, caster)
	if CyGame().getSorenRandNum(100, "Bob") <= gc.getDefineINT('TSUNAMI_FLOOD_CHANCE'):
		if pPlot.isCity():
			pPlot.getPlotCity().kill()
		pPlot.setBonusType(-1)
		pPlot.setImprovementType(-1)
		pPlot.setFeatureType(-1, -1)
		for i in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			pPlot2 = cf.FFHFindClearPlot(pUnit, -1)
			if pPlot2 == -1:
				pUnit.kill(True,0)
			else:
				pUnit.setXY(pPlot2.getX(),pPlot2.getY())
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_COAST'),True,True)

def validTsunami(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	bValid = False
	iX = pPlot.getX()
	iY = pPlot.getY()
	for iiX in range(iX-1, iX+2, 1):
		pPlot2 = CyMap().plot(iiX,iY)
		if pPlot2.isWater():
			bValid = True
	for iiY in range(iY-1, iY+2, 1):
		pPlot2 = CyMap().plot(iX,iiY)
		if pPlot2.isWater():
			bValid = True
	if bValid == False:
		return list
	list.append(pPlot)
	return list

def reqUnholyTaint(caster):
	if not canCast(caster):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNHOLY_TAINT')):
		return False
	return True

def spellUnholyTaint(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNHOLY_TAINT'),True)

def reqUnyieldingOrder(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.isCity() == False:
		return False
	pCity = pPlot.getPlotCity()
	if pCity.hasBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_UNYIELDING_ORDER')):
		return False
	pPlayer = gc.getPlayer(caster.getOwner())
	if not pPlayer.isHuman():
		if pCity.getOwner() != caster.getOwner():
			return False
	return True

def spellUnyieldingOrder(caster):
	doCast(caster)
	pPlot = caster.plot()
	pCity = pPlot.getPlotCity()
	pCity.setHasRealBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_UNYIELDING_ORDER'), True)
	pCity.setOccupationTimer(0)
	pCity.changeHurryAngerTimer(-9)

def reqValor(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DEMON')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD')) == False):
			if pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VALOR')) == False:
				return True
	return False

def spellValor(caster):
	doCast(caster)
	pPlot = caster.plot()
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_DEMON')) == False and pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_UNDEAD')) == False):
			pUnit.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_VALOR'),True)

def reqVitalize(caster):
	if not canCast(caster):
		return False
	pPlot = caster.plot()
	if pPlot.getTerrainType() == CvUtil.getInfoTypeForStringCached('TERRAIN_GRASS'):
		return False
	if pPlot.getOwner() != caster.getOwner():
		return False
	return True

def spellVitalize(caster):
	doCast(caster)
	pPlot = caster.plot()
	if(pPlot.getTerrainType()==CvUtil.getInfoTypeForStringCached('TERRAIN_SNOW')):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_TUNDRA'),True,True)
	elif(pPlot.getTerrainType()==CvUtil.getInfoTypeForStringCached('TERRAIN_TUNDRA')):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_PLAINS'),True,True)
	elif(pPlot.getTerrainType()==CvUtil.getInfoTypeForStringCached('TERRAIN_DESERT')):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_PLAINS'),True,True)
	elif(pPlot.getTerrainType()==CvUtil.getInfoTypeForStringCached('TERRAIN_PLAINS')):
		pPlot.setTerrainType(CvUtil.getInfoTypeForStringCached('TERRAIN_GRASS'),True,True)

def reqWaterWalking(caster):
	if not canCast(caster):
		return False
	if caster.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_WATER_WALKING')):
		return False
	return True

def spellWaterWalking(caster):
	doCast(caster)
	caster.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_WATER_WALKING'),True)

def reqWhirlwind(caster):
	if not canCast(caster):
		return False
	iX = caster.getX()
	iY = caster.getY()
	pPlayer = gc.getPlayer(caster.getOwner())
	if pPlayer.isHuman():
		return True
	iTeam = pPlayer.getTeam()
	eTeam = gc.getTeam(iTeam)
	for iiX in range(iX-1, iX+2, 1):
		for iiY in range(iY-1, iY+2, 1):
			pPlot = CyMap().plot(iiX,iiY)
			for i in range(pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(i)
				i2Team = gc.getPlayer(pUnit.getOwner()).getTeam()
				if (eTeam.isAtWar(i2Team) == True and pPlot.isCity() == False):
					return True
	return False

def spellWhirlwind(caster):
	doCast(caster)
	iX = caster.getX()
	iY = caster.getY()
	for iiX in range(iX-1, iX+2, 1):
		tiX = iiX + (iiX - iX)
		for iiY in range(iY-1, iY+2, 1):
			tiY = iiY + (iiY - iY)
			pPlot = CyMap().plot(iiX,iiY)
			targetPlot = CyMap().plot(tiX,tiY)
			bValid = True
			if (pPlot.isCity() == False):
				for i in range(pPlot.getNumUnits()):
					bValid = True
					pUnit = pPlot.getUnit(i)
					pPlayer = gc.getPlayer(pUnit.getOwner())
					eTeam = gc.getTeam(pPlayer.getTeam())
					if targetPlot.getNumUnits() > 0:
						for ii in range(targetPlot.getNumUnits()):
							pPlayer2 = gc.getPlayer(targetPlot.getUnit(ii).getOwner())
							iTeam2 = pPlayer2.getTeam()
							if eTeam.isAtWar(iTeam2):
								bValid = False
					if (pUnit.getOwner() != caster.getOwner() and targetPlot.isWater() == False and pUnit.isResisted(caster,-10) == False and bValid):
						pUnit.setXY(tiX,tiY)

def spellWither(caster,target):
	doCast(caster)
	target = target[0]
	pPlot = target.plot()
	point = pPlot.getPoint()
	CyEngine().triggerEffect(CvUtil.getInfoTypeForStringCached('EFFECT_WITHER'),point)
	if target.isResisted(caster,0) == False:
		CyInterface().addMessage(target.getOwner(),True,25,'Unit Withered.','AS2D_DISEASED',1,'Art/Interface/Buttons/Spells/Wither.dds',ColorTypes(8),target.getX(),target.getY(),True,True)
		target.setHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_WITHERED'), True)
		startWar(caster.getOwner(), target.getOwner(), caster, target)

def validWither(caster,pPlot):
	list = []
	if inRange(caster,pPlot,1) == False:
		return list
	iMagicImmune = CvUtil.getInfoTypeForStringCached('PROMOTION_MAGIC_IMMUNE')
	iWithered = CvUtil.getInfoTypeForStringCached('PROMOTION_WITHERED')
	for i in range(pPlot.getNumUnits()):
		pUnit = pPlot.getUnit(i)
		if (pUnit.isAlive() and caster.getOwner() != pUnit.getOwner() and pUnit.isHasPromotion(iMagicImmune) == False and pUnit.isHasPromotion(iWithered) == False):
			list.append(pUnit)
	return list
