import Paths
import fileinput
from CvPythonExtensions import *
gc = CyGlobalContext()

class Trophy:
	def __init__(self,name,description,enabledDDS,disabledDDS):
		self.name=name
		self.description=description
		self.enabledDDS = enabledDDS
		self.disabledDDS = disabledDDS
		self.has = False

ALL_TROPHIES = None
TROPHIES = None
TROPHIES_BY_NAME = None

def hasTrophy(name):
	return TROPHIES_BY_NAME[name].has

def addTrophy(trophy):
	trophy = TROPHIES_BY_NAME[trophy]
	if trophy.has == false:
		trophy.has=True
		TROPHIES.append(trophy)
		out = open(Paths.TROPHY_PATH,"a")
		out.write(trophy.name)
		out.write("\n")
		out.flush()
		out.close()

def init():
	global ALL_TROPHIES
	global TROPHIES
	global TROPHIES_BY_NAME
#	out = file("a.txt","w")
	if not ALL_TROPHIES:
		ALL_TROPHIES=[
			Trophy("TROPHY_DEFEATED_ACHERON","Defeated Acheron",'art/interface/buttons/units/Acheron.dds','art/interface/buttons/trophies/AcheronGrey.dds'),
			Trophy("TROPHY_DEFEATED_BASIUM","Defeated Basium",'art/interface/buttons/units/Basium.dds','art/interface/buttons/trophies/BasiumGrey.dds'),
			Trophy("TROPHY_DEFEATED_HYBOREM","Defeated Hyborem",'art/interface/buttons/units/Hyborem.dds','art/interface/buttons/trophies/HyboremGrey.dds'),
			Trophy("TROPHY_DEFEATED_ORTHUS","Defeated Orthus",'art/interface/buttons/units/Orthus.dds','art/interface/buttons/trophies/OrthusGrey.dds'),
			Trophy("TROPHY_VICTORY_AMURITES","Amurite Victory",'art/interface/TeamColor/Amuritesbutton.dds','art/interface/buttons/trophies/AmuritesGrey.dds'),
			Trophy("TROPHY_VICTORY_BALSERAPHS","Balseraph Victory",'art/interface/TeamColor/Balseraphsbutton.dds','art/interface/buttons/trophies/BalseraphsGrey.dds'),
			Trophy("TROPHY_VICTORY_BANNOR","Bannor Victory",'art/interface/TeamColor/Bannorbutton.dds','art/interface/buttons/trophies/BannorGrey.dds'),
			Trophy("TROPHY_VICTORY_CALABIM","Calabim Victory",'art/interface/TeamColor/Calabimbutton.dds','art/interface/buttons/trophies/CalabimGrey.dds'),
			Trophy("TROPHY_VICTORY_CLAN_OF_EMBERS","Clan of Embers Victory",'art/interface/TeamColor/Clanofembersbutton.dds','art/interface/buttons/trophies/ClanofembersGrey.dds'),
			Trophy("TROPHY_VICTORY_DOVIELLO","Doviello Victory",'art/interface/TeamColor/Doviellobutton.dds','art/interface/buttons/trophies/DovielloGrey.dds'),
			Trophy("TROPHY_VICTORY_ELOHIM","Elohim Victory",'art/interface/TeamColor/Elohimbutton.dds','art/interface/buttons/trophies/ElohimGrey.dds'),
			Trophy("TROPHY_VICTORY_GRIGORI","Grigori Victory",'art/interface/TeamColor/Grigoributton.dds','art/interface/buttons/trophies/GrigoriGrey.dds'),
			Trophy("TROPHY_VICTORY_HIPPUS","Hippus Victory",'art/interface/TeamColor/Hippusbutton.dds','art/interface/buttons/trophies/HippusGrey.dds'),
			Trophy("TROPHY_VICTORY_ILLIANS","Illians Victory",'art/interface/TeamColor/Illiansbutton.dds','art/interface/buttons/trophies/IlliansGrey.dds'),
			Trophy("TROPHY_VICTORY_INFERNAL","Infernal Victory",'art/interface/TeamColor/Infernalbutton.dds','art/interface/buttons/trophies/InfernalGrey.dds'),
			Trophy("TROPHY_VICTORY_KHAZAD","Khazad Victory",'art/interface/TeamColor/Khazadbutton.dds','art/interface/buttons/trophies/KhazadGrey.dds'),
			Trophy("TROPHY_VICTORY_KURIOTATES","Kuriotates Victory",'art/interface/TeamColor/Kuriotatesbutton.dds','art/interface/buttons/trophies/KuriotatesGrey.dds'),
			Trophy("TROPHY_VICTORY_LANUN","Lanun Victory",'art/interface/TeamColor/Lanunbutton.dds','art/interface/buttons/trophies/LanunGrey.dds'),
			Trophy("TROPHY_VICTORY_LJOSALFAR","Ljosalfar Victory",'art/interface/TeamColor/Ljosalfarbutton.dds','art/interface/buttons/trophies/LjosalfarGrey.dds'),
			Trophy("TROPHY_VICTORY_LUCHUIRP","Luchuirp Victory",'art/interface/TeamColor/Luchuirpbutton.dds','art/interface/buttons/trophies/LuchuirpGrey.dds'),
			Trophy("TROPHY_VICTORY_MALAKIM","Malakim Victory",'art/interface/TeamColor/Malakimbutton.dds','art/interface/buttons/trophies/MalakimGrey.dds'),
			Trophy("TROPHY_VICTORY_MERCURIANS","Mercurian Victory",'art/interface/TeamColor/Mercuriansbutton.dds','art/interface/buttons/trophies/MercuriansGrey.dds'),
			Trophy("TROPHY_VICTORY_SHEAIM","Sheaim Victory",'art/interface/TeamColor/Sheaimbutton.dds','art/interface/buttons/trophies/SheaimGrey.dds'),
			Trophy("TROPHY_VICTORY_SIDAR","Sidar Victory",'art/interface/TeamColor/Sidarbutton.dds','art/interface/buttons/trophies/SidarGrey.dds'),
			Trophy("TROPHY_VICTORY_SVARTALFAR","Svartalfar Victory",'art/interface/TeamColor/Svartalfarbutton.dds','art/interface/buttons/trophies/SvartalfarGrey.dds'),
			Trophy("TROPHY_VICTORY_ALTAR_OF_THE_LUONNOTAR","Altar of the Luonnotar Victory",'art/interface/buttons/buildings/AltaroftheLuonnotar.dds','art/interface/buttons/trophies/AltaroftheLuonnotarGrey.dds'),
			Trophy("TROPHY_VICTORY_TOWER_OF_MASTERY","Tower of Mastery Victory",'art/interface/buttons/buildings/TowerofMastery.dds','art/interface/buttons/trophies/TowerofMasteryGrey.dds')]
		TROPHIES_BY_NAME = {}
		for t in ALL_TROPHIES:
			TROPHIES_BY_NAME[t.name]=t
		TROPHIES=[]
		for line in fileinput.input(Paths.TROPHY_PATH):
			tr=TROPHIES_BY_NAME[line.strip()]
			tr.has=True
			TROPHIES.append(tr)
#			out.write(line)
#			out.write("\n")
#			out.flush()
#		out.write(str(TROPHIES))
#		out.write("\n")
#		out.flush()
#		out.write(str(ALL_TROPHIES))
#		out.write("\n")
#		out.flush()
#	out.close()
