## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## #####   WARNING - MODIFYING THE FUNCTION NAMES OF THIS FILE IS PROHIBITED  #####
## 
## The app specifically calls the functions as they are named. Use this file to pass 
## args to another file that contains your modifications

#
import CvUtil
import CvGameUtils
import CvEventInterface
import PyHelpers
from CvPythonExtensions import *
import CustomFunctions

cf = CustomFunctions.CustomFunctions()

# globals
gc = CyGlobalContext()
normalGameUtils = CvGameUtils.CvGameUtils()

def gameUtils():
	' replace normalGameUtils with your mod version'
	return normalGameUtils
		
def isVictoryTest():
	#CvUtil.pyPrint( "CvGameInterface.isVictoryTest" )
	return gameUtils().isVictoryTest()

def isPlayerResearch(argsList):
	#CvUtil.pyPrint( "CvGameInterface.isPlayerResearch" )
	return gameUtils().isPlayerResearch(argsList)

def createBarbarianCities():
	#CvUtil.pyPrint( "CvGameInterface.createBarbarianCities" )
	return gameUtils().createBarbarianCities()

def createBarbarianUnits():
	#CvUtil.pyPrint( "CvGameInterface.createBarbarianUnits" )
	return gameUtils().createBarbarianUnits()

def skipResearchPopup(argsList):
	#CvUtil.pyPrint( "CvGameInterface.skipResearchPopup" )
	return gameUtils().skipResearchPopup(argsList)

def showTechChooserButton(argsList):
	#CvUtil.pyPrint( "CvGameInterface.showTechChooserButton" )
	return gameUtils().showTechChooserButton(argsList)

def getFirstRecommendedTech(argsList):
	#CvUtil.pyPrint( "CvGameInterface.getFirstRecommendedTech" )
	return gameUtils().getFirstRecommendedTech(argsList)

def getSecondRecommendedTech(argsList):
	#CvUtil.pyPrint( "CvGameInterface.getSecondRecommendedTech" )
	return gameUtils().getSecondRecommendedTech(argsList)

def skipProductionPopup(argsList):
	#CvUtil.pyPrint( "CvGameInterface.skipProductionPopup" )
	return gameUtils().skipProductionPopup(argsList)

def showExamineCityButton(argsList):
	#CvUtil.pyPrint( "CvGameInterface.showExamineCityButton" )
	return gameUtils().showExamineCityButton(argsList)

def getRecommendedUnit(argsList):
	#CvUtil.pyPrint( "CvGameInterface.getRecommendedUnit" )
	return gameUtils().getRecommendedUnit(argsList)

def getRecommendedBuilding(argsList):
	#CvUtil.pyPrint( "CvGameInterface.getRecommendedBuilding" )
	return gameUtils().getRecommendedBuilding(argsList)

def updateColoredPlots():
	#CvUtil.pyPrint( "CvGameInterface.updateColoredPlots" )
	return gameUtils().updateColoredPlots()

def isActionRecommended(argsList):
	#CvUtil.pyPrint( "CvGameInterface.isActionRecommended" )
	return gameUtils().isActionRecommended(argsList)

def cannotHandleAction(argsList):
	#CvUtil.pyPrint( "CvGameInterface.cannotHandleAction" )
	pPlot, iAction, bTestVisible = argsList
	pAction = gc.getActionInfo(iAction)
	iCommand = pAction.getCommandType()
	iMission = pAction.getMissionType()

	if iCommand == CommandTypes.COMMAND_GIFT:
		pUnit = CyInterface().getHeadSelectedUnit()
		if pUnit.canGift(False):
			unitClassInfo = gc.getUnitClassInfo(pUnit.getUnitClassType())
			if unitClassInfo.getMaxPlayerInstances() != -1:
				return True
			if unitClassInfo.getMaxTeamInstances() != -1 and pUnit.plot().getTeam() != pUnit.getTeam():
				return True

	return gameUtils().cannotHandleAction(argsList)

def cannotSelectionListMove(argsList):
	#CvUtil.pyPrint( "CvGameInterface.cannotSelectionListMove" )
	return gameUtils().cannotSelectionListMove(argsList)

def cannotSelectionListGameNetMessage(argsList):
	#CvUtil.pyPrint( "CvGameInterface.cannotSelectionListGameNetMessage" )
	return gameUtils().cannotSelectionListGameNetMessage(argsList)

def cannotDoControl(argsList):
	#CvUtil.pyPrint( "CvGameInterface.cannotDoControl" )
	return gameUtils().cannotDoControl(argsList)

def canResearch(argsList):
	#CvUtil.pyPrint( "CvGameInterface.canResearch" )
	return gameUtils().canResearch(argsList)

def cannotResearch(argsList):
	ePlayer = argsList[0]
	eTech = argsList[1]
	pPlayer = gc.getPlayer(ePlayer)

	if eTech == CvUtil.getInfoTypeForStringCached('TECH_HIDDEN_PATHS'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES'):
			return True

	if eTech == CvUtil.getInfoTypeForStringCached('TECH_INFERNAL_PACT'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'):
			return True

	if eTech == CvUtil.getInfoTypeForStringCached('TECH_UNQUESTIONING_OBEDIENCE'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER'):
			return True

	if eTech == CvUtil.getInfoTypeForStringCached('TECH_MIND_STAPLING'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS'):
			return True

	if eTech == CvUtil.getInfoTypeForStringCached('TECH_ARETE'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH'):
			return True

	if pPlayer.isHuman() == False:
		if eTech == CvUtil.getInfoTypeForStringCached('TECH_ORDERS_FROM_HEAVEN'):
			if pPlayer.getAlignment() != 1:
				return True

		if eTech == CvUtil.getInfoTypeForStringCached('TECH_WAY_OF_THE_EARTHMOTHER'):
			if pPlayer.getAlignment() == -1:
				return True

		if eTech == CvUtil.getInfoTypeForStringCached('TECH_MESSAGE_FROM_THE_DEEP'):
			if pPlayer.getAlignment() == 1:
				return True

		if eTech == CvUtil.getInfoTypeForStringCached('TECH_CORRUPTION_OF_SPIRIT'):
			if pPlayer.getAlignment() != -1:
				return True

	if eTech == CvUtil.getInfoTypeForStringCached('TECH_SEAFARING'):
		if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_LANUN'):
			return True

	return False

def canDoCivic(argsList):
	#CvUtil.pyPrint( "CvGameInterface.canDoCivic" )
	return gameUtils().canDoCivic(argsList)

def cannotDoCivic(argsList):
	ePlayer = argsList[0]
	eCivic = argsList[1]
	pPlayer = gc.getPlayer(ePlayer)

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_GUARDIAN_OF_NATURE'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_FELLOWSHIP_OF_LEAVES'):
			return True

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_SACRIFICE_THE_WEAK'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'):
			return True

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_SOCIAL_ORDER'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_THE_ORDER'):
			return True

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_SLAVERY'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_OCTOPUS_OVERLORDS'):
			return True

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_ARETE'):
		if pPlayer.getStateReligion() != CvUtil.getInfoTypeForStringCached('RELIGION_RUNES_OF_KILMORPH'):
			return True

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_PUBLIC_HEALERS'):
		if pPlayer.getAlignment() != 1:
			return True

	if eCivic == CvUtil.getInfoTypeForStringCached('CIVIC_CRUSADE'):
		if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_BANNOR'):
			return True
		eTeam = gc.getTeam(pPlayer.getTeam())
		bAtWar = False
		for iPlayer2 in range(gc.getMAX_PLAYERS()):
			pPlayer2 = gc.getPlayer(iPlayer2)
			if (pPlayer2.isAlive() and iPlayer2 != gc.getBARBARIAN_PLAYER()):
				iTeam2 = pPlayer2.getTeam()
				if eTeam.isAtWar(iTeam2):
					bAtWar = True
		if bAtWar == False:
			return True

	return False

def canTrain(argsList):
	#CvUtil.pyPrint( "CvGameInterface.canTrain" )
	return gameUtils().canTrain(argsList)

def cannotTrain(argsList):
	pCity = argsList[0]
	eUnit = argsList[1]
	bContinue = argsList[2]
	bTestVisible = argsList[3]
	ePlayer = pCity.getOwner()
	pPlayer = gc.getPlayer(ePlayer)

	eUnitClass = gc.getUnitInfo(eUnit).getUnitClassType()

	if pPlayer.isHuman() == False:
		if eUnitClass == CvUtil.getInfoTypeForStringCached('UNITCLASS_WARRIOR'):
			if pPlayer.canConstruct(CvUtil.getInfoTypeForStringCached('BUILDING_TRAINING_YARD'), False, False, False):
				return True
			if pPlayer.canConstruct(CvUtil.getInfoTypeForStringCached('BUILDING_ARCHERY_RANGE'), False, False, False):
				return True
		if eUnitClass == CvUtil.getInfoTypeForStringCached('UNITCLASS_SCOUT'):
			if pPlayer.canConstruct(CvUtil.getInfoTypeForStringCached('BUILDING_HUNTING_LODGE'), False, False, False):
				return True
			if pPlayer.canConstruct(CvUtil.getInfoTypeForStringCached('BUILDING_STABLES'), False, False, False):
				return True
		if eUnit == CvUtil.getInfoTypeForStringCached('UNIT_DEMAGOG'):
			if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_DEMAGOG')) > 6:
				return True
		if eUnitClass == CvUtil.getInfoTypeForStringCached('UNITCLASS_SETTLER'):
			if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_KHAZAD'):
				if pPlayer.getGold() / pPlayer.getNumCities() <= 149:
					return True
		if eUnitClass == CvUtil.getInfoTypeForStringCached('UNITCLASS_ADEPT'):
			if pPlayer.getUnitClassCount(CvUtil.getInfoTypeForStringCached('UNITCLASS_ADEPT')) > 2:
				return True

	if eUnit == CvUtil.getInfoTypeForStringCached('UNIT_EIDOLON'):
		if pPlayer.getAlignment() != -1:
			return True

	if (eUnit == CvUtil.getInfoTypeForStringCached('UNIT_PALADIN') or eUnit == CvUtil.getInfoTypeForStringCached('UNIT_ELVEN_PALADIN')):
		if pPlayer.getAlignment() != 1:
			return True

	if (eUnit == CvUtil.getInfoTypeForStringCached('UNIT_DRUID') or eUnit == CvUtil.getInfoTypeForStringCached('UNIT_DWARVEN_DRUID') or eUnit == CvUtil.getInfoTypeForStringCached('UNIT_LIZARDMAN_DRUID')):
		if pPlayer.getAlignment() != 0:
			return True

	if eUnit == CvUtil.getInfoTypeForStringCached('UNIT_BEAST_OF_AGARES'):
		if pCity.getPopulation() <= 5:
			return True

	if pPlayer.getCivics(CvUtil.getInfoTypeForStringCached('CIVICOPTION_CULTURAL_VALUES')) == CvUtil.getInfoTypeForStringCached('CIVIC_CRUSADE'):
		if eUnit == CvUtil.getInfoTypeForStringCached('UNIT_WORKER'):
			return True
		if eUnit == CvUtil.getInfoTypeForStringCached('UNIT_SETTLER'):
			return True

	if pCity.hasBuilding(CvUtil.getInfoTypeForStringCached('BUILDING_SETTLEMENT')):
		return True

	return False

def canConstruct(argsList):
	#CvUtil.pyPrint( "CvGameInterface.canConstruct" )
	return gameUtils().canConstruct(argsList)

def cannotConstruct(argsList):
	pCity = argsList[0]
	eBuilding = argsList[1]
	bContinue = argsList[2]
	bTestVisible = argsList[3]
	bIgnoreCost = argsList[4]
	pPlayer = gc.getPlayer(pCity.getOwner())

	iSettlement = CvUtil.getInfoTypeForStringCached('BUILDING_SETTLEMENT')

	if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_COMMAND_POST'):
		if not pPlayer.hasTrait(CvUtil.getInfoTypeForStringCached('TRAIT_ORGANIZED')):
			return True

	if pPlayer.isHuman() == False:
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_TRAINING_YARD'):
			if (pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_COPPER')) == False and pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_IRON')) == False and pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_MITHRIL')) == False):
				return True

	if (eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_HUMAN_CAGE') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_DWARF_CAGE') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ELF_CAGE') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ORC_CAGE')):
		if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_BALSERAPHS'):
			return True

	if pPlayer.getCivics(CvUtil.getInfoTypeForStringCached('CIVICOPTION_CULTURAL_VALUES')) == CvUtil.getInfoTypeForStringCached('CIVIC_CRUSADE'):
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ELDER_COUNCIL'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_MARKET'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_OBELISK'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_MONEYCHANGER'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_THEATRE'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_AQUEDUCT'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_PUBLIC_BATHS'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_HERBALIST'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_CARNIVAL'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_COURTHOUSE'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_GAMBLING_HOUSE'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_GRANARY'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_SMOKEHOUSE'):
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_BREWERY'):
			return True

	if pCity.hasBuilding(iSettlement):
		bValid = False
		if (eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_MONUMENT') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_WALLS')):
			bValid = True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_CITY'):
			if pPlayer.getBuildingClassCount(CvUtil.getInfoTypeForStringCached("BUILDINGCLASS_CITY")) < cf.FFHGetMaxSprawlingCities():
				bValid = True
		if bValid == False:
			return True

	if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_SHRINE_OF_THE_CHAMPION'):
		iHero = cf.FFHGetHero(pPlayer)
		if iHero == -1:
			return True
		if CyGame().isUnitClassMaxedOut(iHero, 0) == False:
			return True
		if pPlayer.getUnitClassCount(iHero) > 0:
			return True

	if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_CITY'):
		if pCity.hasBuilding(iSettlement) == False:
			return True

	if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_MERCURIAN_GATE'):
		if pPlayer.getStateReligion() == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'):
			return True
		bValid = False
		for iPlayer2 in range(gc.getMAX_PLAYERS()):
			pPlayer2 = gc.getPlayer(iPlayer2)
			if (pPlayer2.isAlive()):
				if pPlayer2.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_INFERNAL'):
					bValid = True
		if bValid == False:
			return True
		if pCity.isCapital():
			return True
		if pPlayer.isHuman() == False:
			if pPlayer.getAlignment() == -1:
				return True

	if (eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_ANOINTED') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_BLESSED') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_CONSECRATED') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_DIVINE') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED') or eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')):
		if pPlayer.getAlignment() == -1:
			return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR'):
			if (pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_ANOINTED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_BLESSED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_CONSECRATED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_DIVINE')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')) > 0):
				return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_ANOINTED'):
			if (pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_BLESSED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_CONSECRATED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_DIVINE')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')) > 0):
				return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_BLESSED'):
			if (pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_CONSECRATED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_DIVINE')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')) > 0):
				return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_CONSECRATED'):
			if (pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_DIVINE')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')) > 0):
				return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_DIVINE'):
			if (pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED')) > 0 or pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')) > 0):
				return True
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_EXALTED'):
			if pPlayer.countNumBuildings(CvUtil.getInfoTypeForStringCached('BUILDING_ALTAR_OF_THE_LUONNOTAR_FINAL')) > 0:
				return True

	if pPlayer.isHuman() == False:
		if eBuilding == CvUtil.getInfoTypeForStringCached('BUILDING_PROPHECY_OF_RAGNAROK'):
			if pPlayer.getAlignment() != -1:
				return True

	return False

def canCreate(argsList):
	#CvUtil.pyPrint( "CvGameInterface.canCreate" )
	return gameUtils().canCreate(argsList)

def cannotCreate(argsList):
	#CvUtil.pyPrint( "CvGameInterface.cannotCreate" )
	pCity = argsList[0]
	eProject = argsList[1]
	bContinue = argsList[2]
	bTestVisible = argsList[3]
	pPlayer = gc.getPlayer(pCity.getOwner())

	if eProject == CvUtil.getInfoTypeForStringCached('PROJECT_ELEGY_OF_THE_SHEAIM'):
		if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_SHEAIM'):
			return True
		if CyGame().getArmageddonCounter() > 99:
			return True

	if eProject == CvUtil.getInfoTypeForStringCached('PROJECT_HALLOWING_OF_THE_ELOHIM'):
		if pPlayer.getCivilizationType() != CvUtil.getInfoTypeForStringCached('CIVILIZATION_ELOHIM'):
			return True
		if CyGame().getArmageddonCounter() < 1:
			return True

	if eProject == CvUtil.getInfoTypeForStringCached('PROJECT_BANE_DIVINE'):
		if (CyGame().getArmageddonCounter() < 70 and pCity.getProductionProject() != CvUtil.getInfoTypeForStringCached('PROJECT_BANE_DIVINE')):
			return True

	if eProject == CvUtil.getInfoTypeForStringCached('PROJECT_GLORY_EVERLASTING'):
		if (CyGame().getArmageddonCounter() < 70 and pCity.getProductionProject() != CvUtil.getInfoTypeForStringCached('PROJECT_GLORY_EVERLASTING')):
			return True
	if eProject == CvUtil.getInfoTypeForStringCached('PROJECT_PURGE_THE_UNFAITHFUL'):
		if pPlayer.getStateReligion() == -1:
			return True

	return gameUtils().cannotCreate(argsList)

def canMaintain(argsList):
	#CvUtil.pyPrint( "CvGameInterface.canMaintain" )
	return gameUtils().canMaintain(argsList)

def cannotMaintain(argsList):
	#CvUtil.pyPrint( "CvGameInterface.cannotMaintain" )
	return gameUtils().cannotMaintain(argsList)

def AI_chooseTech(argsList):
	'AI chooses what to research'
	#CvUtil.pyPrint( "CvGameInterface.AI_chooseTech" )
	ePlayer = argsList[0]
	bFree = argsList[1]
	pPlayer = gc.getPlayer(ePlayer)
	eTeam = gc.getTeam(pPlayer.getTeam())
	iTech = -1

	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_LUCHUIRP'):
		iTech = CvUtil.getInfoTypeForStringCached('TECH_CONSTRUCTION')

	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_LJOSALFAR'):
		iTech = CvUtil.getInfoTypeForStringCached('TECH_WAY_OF_THE_FORESTS')

	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_KHAZAD'):
		iTech = CvUtil.getInfoTypeForStringCached('TECH_WAY_OF_THE_EARTHMOTHER')

	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_LANUN'):
		iTech = CvUtil.getInfoTypeForStringCached('TECH_SAILING')

	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_HIPPUS'):
		iTech = CvUtil.getInfoTypeForStringCached('TECH_HORSEBACK_RIDING')

	if pPlayer.getCivilizationType() == CvUtil.getInfoTypeForStringCached('CIVILIZATION_BALSERAPHS'):
		iTech = CvUtil.getInfoTypeForStringCached('TECH_FESTIVALS')

	if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_EXPLORATION')) == False:
		iTech = CvUtil.getInfoTypeForStringCached('TECH_EXPLORATION')

	if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_PHILOSOPHY')):
		if pPlayer.getAlignment() < 0:
			bValid = true
			for iTeam2 in range(gc.getMAX_PLAYERS()):
				eTeam2 = gc.getTeam(iTeam2)
				if eTeam2.isAlive():
					if eTeam2.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_CORRUPTION_OF_SPIRIT')):
						bValid = false
			if bValid == true:
				iTech = CvUtil.getInfoTypeForStringCached('TECH_CORRUPTION_OF_SPIRIT')

	if eTeam.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_PHILOSOPHY')):
		if pPlayer.getAlignment() > 0:
			bValid = true
			for iTeam2 in range(gc.getMAX_TEAMS()):
				eTeam2 = gc.getTeam(iTeam2)
				if eTeam2.isAlive():
					if eTeam2.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_ORDERS_FROM_HEAVEN')):
						bValid = false
			if bValid == true:
				iTech = CvUtil.getInfoTypeForStringCached('TECH_ORDERS_FROM_HEAVEN')

	if pPlayer.getStateReligion() == CvUtil.getInfoTypeForStringCached('RELIGION_THE_ASHEN_VEIL'):
		bValid = true
		for iTeam2 in range(gc.getMAX_TEAMS()):
			eTeam2 = gc.getTeam(iTeam2)
			if eTeam2.isAlive():
				if eTeam2.isHasTech(CvUtil.getInfoTypeForStringCached('TECH_INFERNAL_PACT')):
					bValid = false
		if bValid == true:
			iTech = CvUtil.getInfoTypeForStringCached('TECH_INFERNAL_PACT')

	if iTech != -1:
		if eTeam.isHasTech(iTech) == False:
			return iTech

	return gameUtils().AI_chooseTech(argsList)

def AI_chooseProduction(argsList):
	'AI chooses city production'
	#CvUtil.pyPrint( "CvGameInterface.AI_chooseProduction" )
	pCity = argsList[0]
	pPlayer = gc.getPlayer(pCity.getOwner())
	infoCiv = gc.getCivilizationInfo(pPlayer.getCivilizationType())

	iT2Min = gc.getDefineINT('AI_MIN_BUILDING_T2')
	iT4Min = gc.getDefineINT('AI_MIN_BUILDING_T4')
	iAlchemyLabClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_ALCHEMY_LAB')
	iAlchemyLab = infoCiv.getCivilizationBuildings(iAlchemyLabClass)
	iArcheryRangeClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_ARCHERY_RANGE')
	iArcheryRange = infoCiv.getCivilizationBuildings(iArcheryRangeClass)
	iBearTotemClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_BEAR_TOTEM')
	iBearTotem = infoCiv.getCivilizationBuildings(iBearTotemClass)
	iBowyerClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_BOWYER')
	iBowyer = infoCiv.getCivilizationBuildings(iBowyerClass)
	iForge = infoCiv.getCivilizationBuildings(CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_FORGE'))
	iGroveClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_GROVE')
	iGrove = infoCiv.getCivilizationBuildings(iGroveClass)
	iHippodromeClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_HIPPODROME')
	iHippodrome = infoCiv.getCivilizationBuildings(iHippodromeClass)
	iHuntingLodgeClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_HUNTING_LODGE')
	iHuntingLodge = infoCiv.getCivilizationBuildings(iHuntingLodgeClass)
	iLargeAnimalStablesClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_LARGE_ANIMAL_STABLES')
	iLargeAnimalStables = infoCiv.getCivilizationBuildings(iLargeAnimalStablesClass)
	iMachinistsShopClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_MACHINISTS_SHOP')
	iMachinistsShop = infoCiv.getCivilizationBuildings(iMachinistsShopClass)
	iMageGuildClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_MAGE_GUILD')
	iMageGuild = infoCiv.getCivilizationBuildings(iMageGuildClass)
	iStablesClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_STABLES')
	iStables = infoCiv.getCivilizationBuildings(iStablesClass)
	iTrainingYardClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_TRAINING_YARD')
	iTrainingYard = infoCiv.getCivilizationBuildings(iTrainingYardClass)
	iWeaponsmithClass = CvUtil.getInfoTypeForStringCached('BUILDINGCLASS_WEAPONSMITH')
	iWeaponsmith = infoCiv.getCivilizationBuildings(iWeaponsmithClass)

	if pPlayer.isBarbarian() == False:

		if pPlayer.getBuildingClassCountPlusMaking(iWeaponsmithClass) < iT4Min:
			if pCity.canConstruct(iWeaponsmith, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iWeaponsmith, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iBearTotemClass) < iT4Min:
			if pCity.canConstruct(iBearTotem, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iBearTotem, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iBowyerClass) < iT4Min:
			if pCity.canConstruct(iBowyer, False, False, False):
				if (pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_MITHRIL')) or pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_IRON'))):
					pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iBowyer, -1, False, False, False, False)
					return 1

		if pPlayer.getBuildingClassCountPlusMaking(iMachinistsShopClass) < iT4Min:
			if pCity.canConstruct(iMachinistsShop, False, False, False):
				if (pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_MITHRIL')) or pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_IRON'))):
					pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iMachinistsShop, -1, False, False, False, False)
					return 1

		if pPlayer.getBuildingClassCountPlusMaking(iGroveClass) < iT4Min:
			if pCity.canConstruct(iGrove, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iGrove, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iAlchemyLabClass) < iT4Min:
			if pCity.canConstruct(iAlchemyLab, False, False, False):
				if pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_GUNPOWDER')):
					pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iAlchemyLab, -1, False, False, False, False)
					return 1

		if pPlayer.getBuildingClassCountPlusMaking(iHippodromeClass) < iT4Min:
			if pCity.canConstruct(iHippodrome, False, False, False):
				if (pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_MITHRIL')) or pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_IRON'))):
					pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iHippodrome, -1, False, False, False, False)
					return 1

		if pPlayer.getBuildingClassCountPlusMaking(iLargeAnimalStablesClass) < iT4Min:
			if pCity.canConstruct(iLargeAnimalStables, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iLargeAnimalStables, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iTrainingYardClass) < iT2Min:
			if pCity.canConstruct(iTrainingYard, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iTrainingYard, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iArcheryRangeClass) < iT2Min:
			if pCity.canConstruct(iArcheryRange, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iArcheryRange, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iHuntingLodgeClass) < iT2Min:
			if pCity.canConstruct(iHuntingLodge, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iHuntingLodge, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iStablesClass) < iT2Min:
			if pCity.canConstruct(iStables, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iStables, -1, False, False, False, False)
				return 1

		if pPlayer.getBuildingClassCountPlusMaking(iMageGuildClass) < iT2Min:
			if pCity.canConstruct(iMageGuild, False, False, False):
				pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iMageGuild, -1, False, False, False, False)
				return 1

		if (iForge != -1 and pCity.hasBuilding(iForge) == False):
			if pCity.canConstruct(iForge, False, False, False):
				if (pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_COPPER')) or pCity.hasBonus(CvUtil.getInfoTypeForStringCached('BONUS_IRON'))):
					pCity.pushOrder(OrderTypes.ORDER_CONSTRUCT, iForge, -1, False, False, False, False)
					return 1

	return gameUtils().AI_chooseProduction(argsList)

def AI_unitUpdate(argsList):
	'AI moves units - return 0 to let AI handle it, return 1 to say that the move is handled in python '
	#CvUtil.pyPrint( "CvGameInterface.AI_unitUpdate" )
	pUnit = argsList[0]

	if pUnit.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_GIANT_SPIDER'):
		iX = pUnit.getX()
		iY = pUnit.getY()
		for iiX in range(iX-1, iX+2, 1):
			for iiY in range(iY-1, iY+2, 1):
				pPlot = CyMap().plot(iiX,iiY)
				for i in range(pPlot.getNumUnits()):
					if pPlot.getUnit(i).getOwner() != pUnit.getOwner():
						return 0
		return 1

	if pUnit.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_HYBOREM'):
		if pUnit.isHasPromotion(CvUtil.getInfoTypeForStringCached('PROMOTION_IMMORTAL')) == False:
			pPlot = pUnit.plot()
			if pPlot.isCity():
				pCity = pPlot.getPlotCity()
				if pCity.getOwner() == pUnit.getOwner():
					return 1

	if pUnit.getUnitClassType() == CvUtil.getInfoTypeForStringCached('UNITCLASS_ACHERON'):
		return 1

	if pUnit.getOwner() == gc.getBARBARIAN_PLAYER():
		pPlot = pUnit.plot()
		if pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_BARROW') or pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_RUINS') or pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_HELLFIRE') or pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_BEAR_DEN') or pPlot.getImprovementType() == CvUtil.getInfoTypeForStringCached('IMPROVEMENT_LION_DEN'):
			if pPlot.getNumUnits() == 1:
				return 1

	return gameUtils().AI_unitUpdate(argsList)

def AI_doWar(argsList):
	'AI decides whether to make war or peace - return 0 to let AI handle it, return 1 to say that the move is handled in python '
	#CvUtil.pyPrint( "CvGameInterface.AI_doWar" )
	return gameUtils().AI_doWar(argsList)

def AI_doDiplo(argsList):
	'AI decides does diplomacy for the turn - return 0 to let AI handle it, return 1 to say that the move is handled in python '
	#CvUtil.pyPrint( "CvGameInterface.AI_doDiplo" )
	return gameUtils().AI_doDiplo(argsList)

def calculateScore(argsList):
	#CvUtil.pyPrint( "CvGameInterface.calculateScore" )
	return gameUtils().calculateScore(argsList)

def doHolyCity():
	#CvUtil.pyPrint( "CvGameInterface.doHolyCity" )
	return gameUtils().doHolyCity()

def doHolyCityTech(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doHolyCityTech" )
	return gameUtils().doHolyCityTech(argsList)

def doGold(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doGold" )
	return gameUtils().doGold(argsList)

def doResearch(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doResearch" )
	return gameUtils().doResearch(argsList)

def doGoody(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doGoody" )
	ePlayer, pPlot, pUnit = argsList

	if pUnit.getSpecialUnitType() == CvUtil.getInfoTypeForStringCached('SPECIALUNIT_SPELL'):
		return 1

	return gameUtils().doGoody(argsList)

def doGrowth(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doGrowth" )
	return gameUtils().doGrowth(argsList)

def doProduction(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doProduction" )
	return gameUtils().doProduction(argsList)

def doCulture(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doCulture" )
	return gameUtils().doCulture(argsList)

def doPlotCulture(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doPlotCulture" )
	return gameUtils().doPlotCulture(argsList)

def doReligion(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doReligion" )
	return gameUtils().doReligion(argsList)

def doGreatPeople(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doGreatPeople" )
	return gameUtils().doGreatPeople(argsList)

def doMeltdown(argsList):
	#CvUtil.pyPrint( "CvGameInterface.doMeltdown" )
	return gameUtils().doMeltdown(argsList)

