from CvPythonExtensions import *
import CvUtil
import ScreenInput
import CvScreenEnums
import CvEventInterface
import time
import CvSpellInterface
# globals
gc = CyGlobalContext()
ArtFileMgr = CyArtFileMgr()
localText = CyTranslator()

SPACE_SIZE = 12
Z_BACKGROUND = -2.1
Z_CONTROLS = Z_BACKGROUND - 0.2

PICK_TARGET_SCREEN_NAME = "PickTargetScreen"
SCREEN_W = 800
SCREEN_H = 500

HEADER_TEXT = "PTSHeaderText"
HEADER_X = SPACE_SIZE
HEADER_Y = SPACE_SIZE



BACKGROUND = "PTSBackground"
BACKGROUND_X =  0
BACKGROUND_Y = 0
BACKGROUND_W = SCREEN_W
BACKGROUND_H = SCREEN_H

EXIT = "PTSExit"
EXIT_X = SCREEN_W/2 + SPACE_SIZE * 3
EXIT_H = 30
EXIT_Y = SCREEN_H - EXIT_H - SPACE_SIZE
EXIT_W = SCREEN_W - EXIT_X - SPACE_SIZE

CAST = "PTSCAST"
CAST_X = SPACE_SIZE
CAST_H = 30
CAST_Y = SCREEN_H - CAST_H - SPACE_SIZE
CAST_W = SCREEN_W/2 - SPACE_SIZE*3

MAIN_PANEL = "PTSMainPanel"
MAIN_PANEL_X = SPACE_SIZE
MAIN_PANEL_Y = 55
MAIN_PANEL_W = BACKGROUND_W - SPACE_SIZE*2
MAIN_PANEL_H = CAST_Y - MAIN_PANEL_Y - SPACE_SIZE*2

ITEM =  "PTSItem"


class CvPickTargetScreen:
	"Spell Target Picker Screen"
		
	def interfaceScreen (self, units, numTargets, userData):
		self.userData = userData
		self.units = units
		self.numTargets = numTargets
		self.selection = []
		screen = self.getScreen()
		if screen.isActive():
			return
		self.doScreen()
	def getScreen(self):
		return CyGInterfaceScreen( PICK_TARGET_SCREEN_NAME, CvScreenEnums.PICK_TARGET_SCREEN )
	def doScreen(self):
		screen = self.getScreen()
		
		screen.setRenderInterfaceOnly(True)
		screen.showScreen(PopupStates.POPUPSTATE_IMMEDIATE, False)
		screen.showWindowBackground(False)
		
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		SCREEN_X = xResolution/2-SCREEN_W/2
		SCREEN_Y = yResolution/2-SCREEN_H/2
		screen.setDimensions(  SCREEN_X, SCREEN_Y, SCREEN_W, SCREEN_H)
		
		#screen.setDimensions(screen.centerX(0), screen.centerY(0), 1024, 768)
		
		#screen.addDDSGFC(BACKGROUND, ArtFileMgr.getInterfaceArtInfo("MAINMENU_SLIDESHOW_LOAD").getPath(), 0, 0, SCREEN_W, SCREEN_H, WidgetTypes.WIDGET_GENERAL, -1, -1 )
		#screen.addPanel( "TechTopPanel", u"", u"", True, False, 0, 0, SCREEN_W, 55, PanelStyles.PANEL_STYLE_TOPBAR )
		#screen.addPanel( "TechBottomPanel", u"", u"", True, False, 0, SCREEN_H-55, SCREEN_W, 55, PanelStyles.PANEL_STYLE_BOTTOMBAR )
		
		#Background
		screen.addPanel(BACKGROUND, u"", u"", True, False, BACKGROUND_X, BACKGROUND_Y, BACKGROUND_W, BACKGROUND_H, PanelStyles.PANEL_STYLE_MAIN )
		
		#Header
		screen.setLabel(HEADER_TEXT, BACKGROUND, u"<font=4b>" + localText.getText("TXT_KEY_SCREEN_PICK_TARGET_TITLE", (self.numTargets,)).upper() + u"</font>", CvUtil.FONT_LEFT_JUSTIFY, HEADER_X, HEADER_Y, Z_CONTROLS, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1)
		
		#screen.setText(EXIT, "Background", localText.getText("TXT_KEY_PEDIA_SCREEN_EXIT", ()).upper(), CvUtil.FONT_RIGHT_JUSTIFY, EXIT_X, EXIT_Y, Z_CONTROLS, FontTypes.TITLE_FONT, WidgetTypes.WIDGET_CLOSE_SCREEN, -1, -1 )
		
		#Buttons
		screen.setButtonGFC(EXIT, localText.getText("TXT_KEY_SCREEN_CANCEL", ()), "", EXIT_X, EXIT_Y, EXIT_W, EXIT_H, WidgetTypes.WIDGET_CLOSE_SCREEN, -1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
		screen.setButtonGFC(CAST, localText.getText("TXT_KEY_SCREEN_CAST", ()), "", CAST_X, CAST_Y, CAST_W, CAST_H, WidgetTypes.WIDGET_GENERAL, -1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
		
		#Main Panel
		screen.addPanel( MAIN_PANEL, u"", u"", True, True, MAIN_PANEL_X, MAIN_PANEL_Y,MAIN_PANEL_W, MAIN_PANEL_H, PanelStyles.PANEL_STYLE_IN)
		
		i = 0
		for unit in self.units:
			#Each unit looks like this:
			#|-----------------------------------------subPanel-------------------------------------------------|
			#||---------||-----------subTextOuter---------||---------------------subPromo----------------------||
			#||         |||--subText-||---subTextSpacer--||| "                                               " ||
			#||  Icon   |||Level     || "               "||| Promo1 Promo2 Promo3 Promo4 ....                  ||
			#||         |||Experience||                  |||                                                   ||
			#||         |||----------||------------------|||                                                   ||
			#||---------||--------------------------------||---------------------------------------------------||
			#|--------------------------------------------------------------------------------------------------|
			#and on top of everything in subPanel is itemID - an invisible imageButton that catches the mouseclicks
			subPanel = MAIN_PANEL+"Sub"+str(i)
			info = gc.getUnitInfo(unit.getUnitType())
			itemID = ITEM+str(i)
			screen.attachPanel(MAIN_PANEL, subPanel,"", "", False, False, PanelStyles.PANEL_STYLE_DAWN)
			screen.attachImageButton(subPanel, "Icon"+subPanel, info.getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM,WidgetTypes.WIDGET_GENERAL, -1, -1, False )
			screen.attachImageButton(subPanel, itemID , info.getButton(), GenericButtonSizes.BUTTON_SIZE_CUSTOM,WidgetTypes.WIDGET_GENERAL, -1, -1, False )
			
			#screen.setPassThru(subPanel, True)
			
			#text
			subTextOuter = "TextPanelOuter" + subPanel
			screen.attachPanel(subPanel,subTextOuter,unit.getName(),"", False, False, PanelStyles.PANEL_STYLE_EMPTY)
			subText = "InnerA" + subTextOuter
			screen.attachPanel(subTextOuter,subText,"","", True, False, PanelStyles.PANEL_STYLE_EMPTY)
			screen.attachLabel(subText,"textLevel"+subText,localText.getText("INTERFACE_PANE_LEVEL", ()) +u" %d"%(unit.getLevel()))
			screen.attachLabel(subText,"textXP"+subText,localText.getText("INTERFACE_PANE_EXPERIENCE", ()) +u": %d/%d"% (unit.getExperience(),unit.experienceNeeded()))
			subTextSpacer = "InnerB"+ subTextOuter
			screen.attachPanel(subTextOuter,subTextSpacer,"","", False, False, PanelStyles.PANEL_STYLE_EMPTY)
			
			#promotion panel
			subPromo = "PromoPanel"+subPanel 
			screen.attachPanel(subPanel,subPromo,localText.getText("TXT_KEY_CONCEPT_PROMOTIONS", ()),"", False, True, PanelStyles.PANEL_STYLE_EMPTY)
			
			#Hack to get around not having weights
			#to alter the amount of space given to the promotion + text panels, alter the ratio of these two strings:
			screen.attachLabel(subTextSpacer ,"space"+subTextSpacer,"                    ")
			screen.attachLabel(subPromo,"space"+subPromo,"                                                                        ")
			#screen.setPassThru("space"+subTextSpacer,True)
			#screen.setPassThru("space"+subPromo,True)
			#screen.setPassThru(subTextSpacer,True)
			#screen.setPassThru(subPromo,True)
			ip = 0
			panel = 0
			subPromo1 = ""
			for p in range(gc.getNumPromotionInfos()):
				if (unit.isHasPromotion(p)):
					screen.attachImageButton( subPromo,"Icon"+subPromo+str(p), gc.getPromotionInfo(p).getButton(), GenericButtonSizes.BUTTON_SIZE_24, WidgetTypes.WIDGET_ACTION, gc.getPromotionInfo(p).getActionInfoIndex(), -1,False )
					#2 rows of 16 each
					screen.setImageButtonAt("Icon"+subPromo+str(p),subPromo, gc.getPromotionInfo(p).getButton(), 24*(ip%16),(ip/16)*24,24,24, WidgetTypes.WIDGET_ACTION, gc.getPromotionInfo(p).getActionInfoIndex(), -1 )
					ip+=1
					
			screen.setImageButtonAt(itemID,subPanel ,"", 0,0,MAIN_PANEL_W,64,WidgetTypes.WIDGET_GENERAL,i,-1)
			screen.moveToFront(itemID )
			i+= 1
		
		#make sure the panels are always the same size (except for the last 1)
		if len(self.units) < 5:
			for i in range(5-len(self.units)):
				subPanel = MAIN_PANEL+"DummySub"+str(i)
				screen.attachPanel(MAIN_PANEL, subPanel,"", "", True, False, PanelStyles.PANEL_STYLE_EMPTY)
				screen.attachLabel(subPanel, "", " ")
				screen.attachLabel(subPanel, "", " ")
				screen.attachLabel(subPanel, "", " ")
				screen.attachLabel(subPanel, "", " ")
		
		
	def handleInput (self, inputClass):
		
		if inputClass.getNotifyCode() == NotifyCode.NOTIFY_CLICKED and inputClass.getFunctionName() == ITEM:
			key = inputClass.getID()
			#CyInterface().addImmediateMessage(str(inputClass.getPythonFile())+"|"+str(inputClass.getData())+"|"+str(inputClass.getNotifyCode())+"|"+str(inputClass.getFunctionName())+"|"+str(inputClass.getID())+"|"+str(inputClass.getData1()),"")
			screen = self.getScreen()
			if self.numTargets == 1:
				if len(self.selection)>0:
					screen.setStyle(MAIN_PANEL+"Sub"+str(self.selection[0]),"Panel_Dawn_Style")
					self.selection.remove(self.selection[0])
				self.selection.append(key)
				screen.setStyle(MAIN_PANEL+"Sub"+str(key),"Panel_TanT_Style")
			else:
				if key in self.selection:
					screen.setStyle(MAIN_PANEL+"Sub"+str(key),"Panel_Dawn_Style")
					self.selection.remove(key)
					return 1
				if len(self.selection) < self.numTargets:
					self.selection.append(key)
					screen.setStyle(MAIN_PANEL+"Sub"+str(key),"Panel_TanT_Style")
					return 1
			return 1
		elif inputClass.getNotifyCode() == NotifyCode.NOTIFY_CLICKED and inputClass.getFunctionName() == CAST:
			#CyInterface().addImmediateMessage("casting","")
			if len(self.selection)<self.numTargets:
				return 1
			self.getScreen().hideScreen()
			u = []
			for i in self.selection:
				u.append(self.units[i])
			CvSpellInterface.targetPicked(u,self.userData)
			return 1
		return 0
	def update(self, iDelta):
		return
